#include "stdafx.h"
#include "../index.h"
#include "FileReader.h"

namespace nsDX9A{
namespace nsFile{
namespace nsFileReader{

//ftHgRXgN^
CFileReader::CFileReader(){
	stream = NULL;
}
//RXgN^
CFileReader::CFileReader(const char* FileName, const char* Mode){
	fopen(FileName, Mode);
}
//fXgN^
CFileReader::~CFileReader(){
	fclose();
}

//fopen
bool CFileReader::fopen(const char* FileName, const char* Mode){
	if(stream){
		DX9AErrOut("Failed : CFileReader::fopen Open Data Already Exists\n");
		return(false);
	}
	if(Mode){
		size_t szMode = strlen(Mode);
		if(szMode>=1 && Mode[0]!='r'){
			DX9AErrOut("Failed : CFileReader::fopen Invalid File Mode\n");
			return(false);
		}
		if(szMode>=2 && Mode[1]=='+'){
			DX9AErrOut("Failed : CFileReader::fopen Invalid File Mode\n");
			return(false);
		}
	}
	stream = ::fopen(FileName, Mode);
	return(stream!=NULL);
}
//fclose
bool CFileReader::fclose(){
	if(stream){
		bool Result = (::fclose(stream) == 0);
		if(Result){
			stream = NULL;
		}
		return(Result);
	}
	return(true);
}
//fisopen
bool CFileReader::fisopen(){
	return(stream!=NULL);
}
//fsize
long CFileReader::fsize(){
	long TempFilePos = ftell();
	fseek(0, SEEK_END);
	long Result = ftell();
	fseek(TempFilePos, SEEK_SET);
	return(Result);
}

//fgetc
bool CFileReader::fgetc(char* c){
	int Temp;
	Temp = ::fgetc(stream);
	*c = static_cast<char>(Temp);
	return(Temp!=EOF);
}
//fgets
bool CFileReader::fgets(char* str, int n){
	return(::fgets(str, n, stream)!=NULL);
}
//fread
size_t CFileReader::fread(void* buffer, size_t size, size_t count){
	return(::fread(buffer, size, count, stream));
}

//ftell
long CFileReader::ftell(){
	return(::ftell(stream));
}
//fseek
bool CFileReader::fseek(long offset, int origin){
	return(::fseek(stream, offset, origin)==0);
}
//fgetpos
bool CFileReader::fgetpos(fpos_t* pos){
	return(::fgetpos(stream, pos)==0);
}
//fsetpos
bool CFileReader::fsetpos(const fpos_t* pos){
	return(::fsetpos(stream, pos)==0);
}

//feof
bool CFileReader::feof(){
	return(::feof(stream)!=0);
}
//ferror
int CFileReader::ferror(){
	return(::ferror(stream));
}



//⏕֐
//Íǂݍ
void LoadCryptedString(IFileReader* FileReader, BYTE CryptKey, string* Data){
	unsigned int i=0;
	char strData[64 * 1024] = {0};
	while(true){
		FileReader->fread(strData+i, sizeof(char), 1);
		if(strData[i]=='\0'){
			break;
		}
		else{
			if(strData[i]!=CryptKey){
				strData[i] ^= CryptKey;
			}
			i += 1;
		}
	}
	Data->assign(strData);
}

}
}
}