#include "stdafx.h"
#include "../index.h"
#include "FileWriter.h"

namespace nsDX9A{
namespace nsFile{
namespace nsFileWriter{

//ftHgRXgN^
CFileWriter::CFileWriter(){
	stream = NULL;
}
//RXgN^
CFileWriter::CFileWriter(const char* FileName, const char* Mode){
	fopen(FileName, Mode);
}
//fXgN^
CFileWriter::~CFileWriter(){
	fclose();
}

//fopen
bool CFileWriter::fopen(const char* FileName, const char* Mode){
	if(stream){
		DX9AErrOut("Failed : CFileWriter::fopen Open Data Already Exists\n");
		return(false);
	}
	if(Mode){
		size_t szMode = strlen(Mode);
		if(szMode>=1 && Mode[0]=='r'){
			DX9AErrOut("Failed : CFileWriter::fopen Invalid File Mode\n");
			return(false);
		}
	}
	stream = ::fopen(FileName, Mode);
	return(stream!=NULL);
}
//fclose
bool CFileWriter::fclose(){
	if(stream){
		bool Result = (::fclose(stream) == 0);
		if(Result){
			stream = NULL;
		}
		return(Result);
	}
	return(true);
}
//fisopen
bool CFileWriter::fisopen(){
	return(stream!=NULL);
}
//fsize
long CFileWriter::fsize(){
	long TempFilePos = ftell();
	fseek(0, SEEK_END);
	long Result = ftell();
	fseek(TempFilePos, SEEK_SET);
	return(Result);
}

//fputc
bool CFileWriter::fputc(char c){
	return(::fputc(c, stream)!=EOF);
}
//fputs
bool CFileWriter::fputs(const char* str){
	return(::fputs(str, stream)!=EOF);
}
//fwrite
size_t CFileWriter::fwrite(const void* buffer, size_t size, size_t count){
	return(::fwrite(buffer, size, count, stream));
}
//fprintf
int __cdecl CFileWriter::fprintf(const char* format, ...){
	char buffer[64 * 1024];
	const int n = wvsprintf(buffer, format, reinterpret_cast<va_list>(&format+1)) - 1;
	if(buffer[n]=='\n'){
		buffer[n+1] = '\0';
	}
	return(::fprintf(stream, "%s", buffer));
}

//ftell
long CFileWriter::ftell(){
	return(::ftell(stream));
}
//fseek
bool CFileWriter::fseek(long offset, int origin){
	return(::fseek(stream, offset, origin)==0);
}
//fgetpos
bool CFileWriter::fgetpos(fpos_t* pos){
	return(::fgetpos(stream, pos)==0);
}
//fsetpos
bool CFileWriter::fsetpos(const fpos_t* pos){
	return(::fsetpos(stream, pos)==0);
}

//feof
bool CFileWriter::feof(){
	return(::feof(stream)!=0);
}
//ferror
int CFileWriter::ferror(){
	return(::ferror(stream));
}



//⏕֐
//Í
void SaveCryptedString(IFileWriter* FileWriter, BYTE CryptKey, const string& Data){
	char strData[64 * 1024] = {0};
	strcpy(strData, Data.c_str());
	for(unsigned int i=0;strData[i]!='\0';i++){
		if(strData[i]!=CryptKey){
			strData[i] ^= CryptKey;
		}
	}
	FileWriter->fwrite(strData, strlen(strData)+1, 1);
}

}
}
}