#include "stdafx.h"
#include "../../index.h"
#include "DrawManagerfD.h"
#ifdef USE_ABYSSLIB

namespace nsDX9A{
namespace nsFramework{
namespace nsAbyssLib{
namespace nsDrawManagerfD{

//RXgN^
DrawManagerfD::DrawManagerfD(DX9AGraphic* GM, D3DCOLOR ColorKey, DX9AFilePack* FPM, const string& FilePackName) : m_Draw2DMapList(GM, ColorKey, FPM, FilePackName), m_Draw2DFastMapList(GM, 0, FPM, FilePackName){
	m_GM = GM;
	m_ColorKey = ColorKey;
	m_FPM = FPM;
	m_FilePackName = FilePackName;
}
//ʂ̉擾
unsigned int DrawManagerfD::GetScreenWidth() const{
	return(m_GM->GetScreenWidth());
}
//ʂ̏c擾
unsigned int DrawManagerfD::GetScreenHeight() const{
	return(m_GM->GetScreenHeight());
}
//tXN[ۂ擾
bool DrawManagerfD::GetFullScreen() const{
	return(m_GM->GetFullScreen());
}
//tXN[ۂݒ
void DrawManagerfD::SetFullScreen(bool IsFullScreen){
	m_GM->SetFullScreen(IsFullScreen);
}

//ʂXV
void DrawManagerfD::Flip(){
	m_GM->Present();
}

//OtBbNǗNXiFj擾
IDraw2D* DrawManagerfD::GetDrawer(const string& FileName){
	if(m_ColorKey==0){
		return(m_Draw2DFastMapList.GetDrawer(FileName));
	}
	else{
		return(m_Draw2DMapList.GetDrawer(FileName));
	}
}
//OtBbNǗNXiFȂj擾
IDraw2D* DrawManagerfD::GetDrawerFast(const string& FileName){
	return(m_Draw2DFastMapList.GetDrawer(FileName));
}

bool DrawManagerfD::_LoadImage(const char* FileName){
	if(m_Draw2DFastMapList.GetDrawer(FileName)==NULL){
		CDraw2D* Temp = new CDraw2D(m_GM, new CDraw2DReader(m_GM, m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName));
		if(Temp->GetReader()->IsRead()){
			m_Draw2DFastMapList.CreateDrawer(FileName, FileName);
			if(m_ColorKey!=0){
				m_Draw2DMapList.CreateDrawer(FileName, FileName);
			}
			return(true);
		}
		else{
			SAFE_RELEASE(Temp);
		}
	}
	return(false);
}
bool DrawManagerfD::_UnloadImage(const char* FileName){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		m_Draw2DFastMapList.ReleaseDrawer(FileName);
	}
	if(m_ColorKey!=0){
		if(m_Draw2DMapList.GetDrawer(FileName)!=NULL){
			m_Draw2DMapList.ReleaseDrawer(FileName);
		}
	}
	return(true);
}
void DrawManagerfD::_Clear(COLORREF Color){
	m_GM->Clear(COLORREFTOD3DCOLOR(Color));
}
void DrawManagerfD::_Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		if(m_ColorKey==0){
			m_Draw2DFastMapList.GetDrawer(FileName)->Blt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
		else{
			m_Draw2DMapList.GetDrawer(FileName)->Blt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
	}
}
void DrawManagerfD::_AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		if(m_ColorKey==0){
			m_Draw2DFastMapList.GetDrawer(FileName)->AddBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
		else{
			m_Draw2DMapList.GetDrawer(FileName)->AddBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
	}
}
void DrawManagerfD::_SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		if(m_ColorKey==0){
			m_Draw2DFastMapList.GetDrawer(FileName)->SubBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
		else{
			m_Draw2DMapList.GetDrawer(FileName)->SubBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
		}
	}
}
void DrawManagerfD::_BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		m_Draw2DFastMapList.GetDrawer(FileName)->Blt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
	}
}
void DrawManagerfD::_AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		m_Draw2DFastMapList.GetDrawer(FileName)->AddBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
	}
}
void DrawManagerfD::_SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){
	if(m_Draw2DFastMapList.GetDrawer(FileName)!=NULL){
		m_Draw2DFastMapList.GetDrawer(FileName)->SubBlt(x, y, a, &SrcRect, ScalingX, ScalingY, Degree);
	}
}
void DrawManagerfD::_DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree){
	BYTE r, g, b;
	r = GetRValue(Color);
	g = GetGValue(Color);
	b = GetBValue(Color);
	m_GM->DrawFreeText(Text, x, y, D3DCOLOR_ARGB(a, r, g, b), Font, Size, IsBold, IsItalic, Degree);
}
void DrawManagerfD::_DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree){
	BYTE r, g, b;
	r = GetRValue(Color);
	g = GetGValue(Color);
	b = GetBValue(Color);
	m_GM->DrawRect(Rect, D3DCOLOR_ARGB(a, r, g, b), Degree);
}

}
}
}
}

#endif