#include "stdafx.h"
#include "../../index.h"
#include "SoundManagerfD.h"
#ifdef USE_ABYSSLIB

namespace nsDX9A{
namespace nsFramework{
namespace nsAbyssLib{
namespace nsSoundManagerfD{


//RXgN^
SoundManagerfD::SoundManagerfD(DX9ASound* SM, DX9AFilePack* FPM, const string& FilePackName) : m_BGM(SM) {
	m_SM = SM;
	m_FPM = FPM;
	m_FilePackName = FilePackName;
}

//SẺʂݒ
void SoundManagerfD::_SetSEVolume(long Volume){
	for(map<string, CSoundSE*>::iterator it=m_SE.begin();it!=m_SE.end();it++){
		it->second->SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
	}
}
//SEĐ
bool SoundManagerfD::_PlaySE(const char* FileName){
	return(m_SE.find(FileName)->second->Play(false));
}
//SE~
bool SoundManagerfD::_StopSE(const char* FileName){
	return(m_SE.find(FileName)->second->Stop());
}
//SEɓǂݍ
bool SoundManagerfD::_LoadSE(const char* FileName){
	//e`FbN
	if(strcmp(FileName, "")==0){
		return(true);
	}
	if(m_SE.find(FileName)!=m_SE.end()){
		return(true);
	}
	//TEhf[^ǂݍ݃NX쐬
	ISoundReader* Reader = NULL;
	if(strstr(FileName, ".wav")){
		Reader = new CWavReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#ifdef USE_OGG
	else if(strstr(FileName, ".ogg")){
		Reader = new COggReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#endif
	if(Reader->IsOpen()){
		CSoundSE* Temp = new CSoundSE(m_SM, Reader);
		m_SE.insert(pair<string, CSoundSE*>(FileName, Temp));
		return(true);
	}
	else{
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : SoundManagerfD::_LoadSE Open\n");
		return(false);
	}
}
//SE
bool SoundManagerfD::_UnloadSE(const char* FileName){
	m_SE.find(FileName)->second->Release();
	m_SE.erase(m_SE.find(FileName));
	return(true);
}
//SEĐmF
bool SoundManagerfD::_IsPlayingSE(const char* FileName) const{
	return(m_SE.find(FileName)->second->IsPlaying());
}
//BGM̉ʂݒ
void SoundManagerfD::_SetBGMVolume(long Volume){
	m_BGM.SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
}
//BGMĐ
bool SoundManagerfD::_PlayBGM(bool IsOnce){
	return(m_BGM.Play(!IsOnce));
}
//BGM~
bool SoundManagerfD::_StopBGM(){
	return(m_BGM.Stop());
}
//BGMɓǂݍ
bool SoundManagerfD::_LoadBGM(const char* FileName){
	//e`FbN
	if(strcmp(FileName, "")==0){
		return(true);
	}
	//TEhf[^ǂݍ݃NX쐬
	ISoundReader* Reader = NULL;
	if(strstr(FileName, ".wav")){
		Reader = new CWavReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#ifdef USE_OGG
	else if(strstr(FileName, ".ogg")){
		Reader = new COggReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#endif
	if(Reader->IsOpen()){
		m_BGM.SetReader(Reader);
		return(true);
	}
	else{
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : SoundManagerfD::_LoadBGM Open\n");
		return(false);
	}
}
//BGM
bool SoundManagerfD::_UnloadBGM(){
	m_BGM.SetReader(NULL);
	return(true);
}
//BGMĐmF
bool SoundManagerfD::_IsPlayingBGM() const{
	return(m_BGM.IsPlaying());
}
//̉ʂݒ
void SoundManagerfD::_SetVoiceVolume(long Volume){
	for(map<string, CSoundSE*>::iterator it=m_Voice.begin();it!=m_Voice.end();it++){
		it->second->SetVolume(Volume==0 ? -10000 : static_cast<long>((10*log10(static_cast<double>(Volume)/10000))*100));
	}
}
//Đ
bool SoundManagerfD::_PlayVoice(const char* FileName){
	return(m_Voice.find(FileName)->second->Play(false));
}
//~
bool SoundManagerfD::_StopVoice(const char* FileName){
	return(m_Voice.find(FileName)->second->Stop());
}
//ɓǂݍ
bool SoundManagerfD::_LoadVoice(const char* FileName){
	//e`FbN
	if(strcmp(FileName, "")==0){
		return(true);
	}
	if(m_Voice.find(FileName)!=m_Voice.end()){
		return(true);
	}
	//TEhf[^ǂݍ݃NX쐬
	ISoundReader* Reader = NULL;
	if(strstr(FileName, ".wav")){
		Reader = new CWavReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#ifdef USE_OGG
	else if(strstr(FileName, ".ogg")){
		Reader = new COggReader(m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName);
	}
#endif
	if(Reader->IsOpen()){
		CSoundSE* Temp = new CSoundSE(m_SM, Reader);
		m_Voice.insert(pair<string, CSoundSE*>(FileName, Temp));
		return(true);
	}
	else{
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : SoundManagerfD::_LoadVoice Open\n");
		return(false);
	}
}
//
bool SoundManagerfD::_UnloadVoice(const char* FileName){
	m_Voice.find(FileName)->second->Release();
	m_Voice.erase(m_Voice.find(FileName));
	return(true);
}
//ĐmF
bool SoundManagerfD::_IsPlayingVoice(const char* FileName) const{
	return(m_Voice.find(FileName)->second->IsPlaying());
}

}
}
}
}

#endif