#include "stdafx.h"
#include "../index.h"
#include "DX9AInputHelper.h"

namespace nsDX9A{
namespace nsFramework{
namespace nsDX9AInputHelper{

//RXgN^
DX9AInputHelper::DX9AInputHelper(DX9AInput* IM, DX9AGraphic* GM){
	m_IM = IM;
	m_GM = GM;
	for(int i=0;i<2;i++){
		ZeroMemory(m_KIS[i].Key, sizeof(m_KIS[i].Key));
	}
	m_MouseCursorPos.x = m_MouseCursorPos.y = 0;
	m_MouseWheelPos = 0;
	for(int i=0;i<MOUSE_BUTTON_MAX;i++){
		for(int j=0;j<2;j++){
			m_MBIS[i][j] = false;
		}
	}
	m_ISIT = 0;
}

//͏XV
void DX9AInputHelper::Flush(){
	m_IM->Flush(m_GM->GetFullScreen());
	m_ISIT = 1 - m_ISIT;
	m_KIS[m_ISIT] = m_IM->GetKey();
	m_IM->GetMousePos(m_MouseCursorPos);
	m_MouseWheelPos = m_IM->GetMouseWheel();
	for(BYTE i=0;i<MOUSE_BUTTON_MAX;i++){
		m_MBIS[i][m_ISIT] = m_IM->GetMouseButton(i);
	}
	m_JBIS[m_ISIT].clear();
	for(int i=0;i<static_cast<int>(m_IM->GetJoyNum());i++){
		m_JBIS[m_ISIT].push_back(Joystick());
		m_IM->GetJoystick(m_JBIS[m_ISIT].back(), i);
	}
}

//L[{[h֌W
//L[Ԃ擾
KeyBoard DX9AInputHelper::GetKey() const{
	return(m_IM->GetKey());
}
//Ԃ̗L
bool DX9AInputHelper::Key(BYTE Code) const{
	return(m_KIS[m_ISIT].Key[Code]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushKey(BYTE Code) const{
	return(m_KIS[m_ISIT].Key[Code] && !m_KIS[1-m_ISIT].Key[Code]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpKey(BYTE Code) const{
	return(!m_KIS[m_ISIT].Key[Code] && m_KIS[1-m_ISIT].Key[Code]);
}
//ꂩ̃L[ꂽH
bool DX9AInputHelper::IsAnyKey() const{
	for(int i=0;i<KEY_MAX;i++){
		if(m_KIS[m_ISIT].Key[i]){
			return(true);
		}
	}
	return(false);
}

//}EX֌W
//ʒuݒ
void DX9AInputHelper::SetMousePos(POINT Pos){
	m_IM->SetMousePos(Pos);
	m_IM->GetMousePos(m_MouseCursorPos);
}
//ʒu擾
void DX9AInputHelper::GetMousePos(POINT& Pos) const{
	Pos.x = m_MouseCursorPos.x;
	Pos.y = m_MouseCursorPos.y;
}
//zC[擾
int DX9AInputHelper::GetMouseWheel() const{
	return(m_MouseWheelPos);
}
//Ԃ̗L
bool DX9AInputHelper::LButton() const{
	return(m_MBIS[0][m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushLButton() const{
	return(m_MBIS[0][m_ISIT] && !m_MBIS[0][1-m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpLButton() const{
	return(!m_MBIS[0][m_ISIT] && m_MBIS[0][1-m_ISIT]);
}
//Ԃ̗L
bool DX9AInputHelper::MButton() const{
	return(m_MBIS[2][m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushMButton() const{
	return(m_MBIS[2][m_ISIT] && !m_MBIS[2][1-m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpMButton() const{
	return(!m_MBIS[2][m_ISIT] && m_MBIS[2][1-m_ISIT]);
}
//Ԃ̗L
bool DX9AInputHelper::RButton() const{
	return(m_MBIS[1][m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushRButton() const{
	return(m_MBIS[1][m_ISIT] && !m_MBIS[1][1-m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpRButton() const{
	return(!m_MBIS[1][m_ISIT] && m_MBIS[1][1-m_ISIT]);
}
//Ԃ̗L
bool DX9AInputHelper::MouseButton(BYTE Code) const{
	return(m_MBIS[Code][m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushMouseButton(BYTE Code) const{
	return(m_MBIS[Code][m_ISIT] && !m_MBIS[Code][1-m_ISIT]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpMouseButton(BYTE Code) const{
	return(!m_MBIS[Code][m_ISIT] && m_MBIS[Code][1-m_ISIT]);
}
//ꂩ̃}EX{^ꂽH
bool DX9AInputHelper::IsAnyMouseButton() const{
	for(int i=0;i<MOUSE_BUTTON_MAX;i++){
		if(m_MBIS[i][m_ISIT]){
			return(true);
		}
	}
	return(false);
}

//WCXeBbN֌W
//擾
DWORD DX9AInputHelper::GetJoyNum() const{
	return(m_IM->GetJoyNum());
}
//Vтݒ
void DX9AInputHelper::SetAllow(int AllowX, int AllowY){
	m_IM->SetAllow(AllowX, AllowY);
}
//͏擾
void DX9AInputHelper::GetJoystick(Joystick& Data, DWORD ID) const{
	m_IM->GetJoystick(Data, ID);
}
//Ԃ̗L
bool DX9AInputHelper::JoyButton(BYTE Code, DWORD ID) const{
	if(ID>=GetJoyNum()){
		return(false);
	}
	return(m_JBIS[m_ISIT].at(ID).Button[Code]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushJoyButton(BYTE Code, DWORD ID) const{
	if(ID>=GetJoyNum()){
		return(false);
	}
	return(m_JBIS[m_ISIT].at(ID).Button[Code] && !m_JBIS[1-m_ISIT].at(ID).Button[Code]);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpJoyButton(BYTE Code, DWORD ID) const{
	if(ID>=GetJoyNum()){
		return(false);
	}
	return(!m_JBIS[m_ISIT].at(ID).Button[Code] && m_JBIS[1-m_ISIT].at(ID).Button[Code]);
}
//ꂩ̃WCXeBbN{^ꂽH
bool DX9AInputHelper::IsAnyJoyButton() const{
	for(unsigned int i=0;i<m_JBIS[m_ISIT].size();i++){
		for(unsigned int j=0;j<JOYSTICK_BUTTON_MAX;j++){
			if(m_JBIS[m_ISIT].at(i).Button[j]){
				return(true);
			}
		}
	}
	return(false);
}

//z{^֌W
//Sz{^NA
void DX9AInputHelper::ClearAllVirtualButton(){
	m_VBKIS.clear();
	m_VBMBIS.clear();
	m_VBJBIS.clear();
	m_VBJBLIS.clear();
	m_VBJBRIS.clear();
	m_VBJBUIS.clear();
	m_VBJBDIS.clear();
}
//z{^NA
void DX9AInputHelper::ClearVirtualButton(BYTE VirtualCode){
	if(m_VBKIS.find(VirtualCode)!=m_VBKIS.end()){
		m_VBKIS.erase(m_VBKIS.lower_bound(VirtualCode), m_VBKIS.upper_bound(VirtualCode));
	}
	if(m_VBMBIS.find(VirtualCode)!=m_VBMBIS.end()){
		m_VBMBIS.erase(m_VBMBIS.lower_bound(VirtualCode), m_VBMBIS.upper_bound(VirtualCode));
	}
	if(m_VBJBIS.find(VirtualCode)!=m_VBJBIS.end()){
		m_VBJBIS.erase(m_VBJBIS.lower_bound(VirtualCode), m_VBJBIS.upper_bound(VirtualCode));
	}
	if(m_VBJBLIS.find(VirtualCode)!=m_VBJBLIS.end()){
		m_VBJBLIS.erase(m_VBJBLIS.lower_bound(VirtualCode), m_VBJBLIS.upper_bound(VirtualCode));
	}
	if(m_VBJBRIS.find(VirtualCode)!=m_VBJBRIS.end()){
		m_VBJBRIS.erase(m_VBJBRIS.lower_bound(VirtualCode), m_VBJBRIS.upper_bound(VirtualCode));
	}
	if(m_VBJBUIS.find(VirtualCode)!=m_VBJBUIS.end()){
		m_VBJBUIS.erase(m_VBJBUIS.lower_bound(VirtualCode), m_VBJBUIS.upper_bound(VirtualCode));
	}
	if(m_VBJBDIS.find(VirtualCode)!=m_VBJBDIS.end()){
		m_VBJBDIS.erase(m_VBJBDIS.lower_bound(VirtualCode), m_VBJBDIS.upper_bound(VirtualCode));
	}
}
//z{^ݒiL[j
void DX9AInputHelper::SetVirtualButtonK(BYTE VirtualCode, BYTE Code){
	if(m_VBKIS.find(VirtualCode)!=m_VBKIS.end()){
		m_VBKIS.erase(m_VBKIS.lower_bound(VirtualCode), m_VBKIS.upper_bound(VirtualCode));
	}
	m_VBKIS.insert(pair<BYTE, BYTE>(VirtualCode, Code));
}
//z{^ǉiL[j
void DX9AInputHelper::AddVirtualButtonK(BYTE VirtualCode, BYTE Code){
	m_VBKIS.insert(pair<BYTE, BYTE>(VirtualCode, Code));
}
//z{^ݒi}EXj
void DX9AInputHelper::SetVirtualButtonM(BYTE VirtualCode, BYTE Code){
	if(m_VBMBIS.find(VirtualCode)!=m_VBMBIS.end()){
		m_VBMBIS.erase(m_VBMBIS.lower_bound(VirtualCode), m_VBMBIS.upper_bound(VirtualCode));
	}
	m_VBMBIS.insert(pair<BYTE, BYTE>(VirtualCode, Code));
}
//z{^ǉi}EXj
void DX9AInputHelper::AddVirtualButtonM(BYTE VirtualCode, BYTE Code){
	m_VBMBIS.insert(pair<BYTE, BYTE>(VirtualCode, Code));
}
//z{^ݒiWCXeBbNj
void DX9AInputHelper::SetVirtualButtonJ(BYTE VirtualCode, BYTE Code, DWORD ID){
	if(m_VBJBIS.find(VirtualCode)!=m_VBJBIS.end()){
		m_VBJBIS.erase(m_VBJBIS.lower_bound(VirtualCode), m_VBJBIS.upper_bound(VirtualCode));
	}
	m_VBJBIS.insert(pair<BYTE, pair<DWORD, BYTE> >(VirtualCode, pair<DWORD, BYTE>(ID, Code)));
}
//z{^ǉiWCXeBbNj
void DX9AInputHelper::AddVirtualButtonJ(BYTE VirtualCode, BYTE Code, DWORD ID){
	m_VBJBIS.insert(pair<BYTE, pair<DWORD, BYTE> >(VirtualCode, pair<DWORD, BYTE>(ID, Code)));
}
//z{^ݒiWCXeBbNijj
void DX9AInputHelper::SetVirtualButtonJL(BYTE VirtualCode, DWORD ID){
	if(m_VBJBLIS.find(VirtualCode)!=m_VBJBLIS.end()){
		m_VBJBLIS.erase(m_VBJBLIS.lower_bound(VirtualCode), m_VBJBLIS.upper_bound(VirtualCode));
	}
	m_VBJBLIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ǉiWCXeBbNijj
void DX9AInputHelper::AddVirtualButtonJL(BYTE VirtualCode, DWORD ID){
	m_VBJBLIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ݒiWCXeBbNiEjj
void DX9AInputHelper::SetVirtualButtonJR(BYTE VirtualCode, DWORD ID){
	if(m_VBJBRIS.find(VirtualCode)!=m_VBJBRIS.end()){
		m_VBJBRIS.erase(m_VBJBRIS.lower_bound(VirtualCode), m_VBJBRIS.upper_bound(VirtualCode));
	}
	m_VBJBRIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ǉiWCXeBbNiEjj
void DX9AInputHelper::AddVirtualButtonJR(BYTE VirtualCode, DWORD ID){
	m_VBJBRIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ݒiWCXeBbNijj
void DX9AInputHelper::SetVirtualButtonJU(BYTE VirtualCode, DWORD ID){
	if(m_VBJBUIS.find(VirtualCode)!=m_VBJBUIS.end()){
		m_VBJBUIS.erase(m_VBJBUIS.lower_bound(VirtualCode), m_VBJBUIS.upper_bound(VirtualCode));
	}
	m_VBJBUIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ǉiWCXeBbNijj
void DX9AInputHelper::AddVirtualButtonJU(BYTE VirtualCode, DWORD ID){
	m_VBJBUIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ݒiWCXeBbNijj
void DX9AInputHelper::SetVirtualButtonJD(BYTE VirtualCode, DWORD ID){
	if(m_VBJBDIS.find(VirtualCode)!=m_VBJBDIS.end()){
		m_VBJBDIS.erase(m_VBJBDIS.lower_bound(VirtualCode), m_VBJBDIS.upper_bound(VirtualCode));
	}
	m_VBJBDIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//z{^ǉiWCXeBbNijj
void DX9AInputHelper::AddVirtualButtonJD(BYTE VirtualCode, DWORD ID){
	m_VBJBDIS.insert(pair<BYTE, DWORD>(VirtualCode, ID));
}
//Ԃ̗L
bool DX9AInputHelper::VirtualButton(BYTE VirtualCode) const{
	if(m_VBKIS.find(VirtualCode)!=m_VBKIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBKIS.lower_bound(VirtualCode);it!=m_VBKIS.upper_bound(VirtualCode);it++){
			if(Key(it->second)){
				return(true);
			}
		}
	}
	if(m_VBMBIS.find(VirtualCode)!=m_VBMBIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBMBIS.lower_bound(VirtualCode);it!=m_VBMBIS.upper_bound(VirtualCode);it++){
			if(MouseButton(it->second)){
				return(true);
			}
		}
	}
	if(m_VBJBIS.find(VirtualCode)!=m_VBJBIS.end()){
		for(multimap<BYTE, pair<DWORD, BYTE> >::const_iterator it=m_VBJBIS.lower_bound(VirtualCode);it!=m_VBJBIS.upper_bound(VirtualCode);it++){
			if(JoyButton(it->second.second, it->second.first)){
				return(true);
			}
		}
	}
	if(m_VBJBLIS.find(VirtualCode)!=m_VBJBLIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBLIS.lower_bound(VirtualCode);it!=m_VBJBLIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Left){
				return(true);
			}
		}
	}
	if(m_VBJBRIS.find(VirtualCode)!=m_VBJBRIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBRIS.lower_bound(VirtualCode);it!=m_VBJBRIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Right){
				return(true);
			}
		}
	}
	if(m_VBJBUIS.find(VirtualCode)!=m_VBJBUIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBUIS.lower_bound(VirtualCode);it!=m_VBJBUIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Up){
				return(true);
			}
		}
	}
	if(m_VBJBDIS.find(VirtualCode)!=m_VBJBDIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBDIS.lower_bound(VirtualCode);it!=m_VBJBDIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Down){
				return(true);
			}
		}
	}
	return(false);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushVirtualButton(BYTE VirtualCode) const{
	if(m_VBKIS.find(VirtualCode)!=m_VBKIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBKIS.lower_bound(VirtualCode);it!=m_VBKIS.upper_bound(VirtualCode);it++){
			if(PushKey(it->second)){
				return(true);
			}
		}
	}
	if(m_VBMBIS.find(VirtualCode)!=m_VBMBIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBMBIS.lower_bound(VirtualCode);it!=m_VBMBIS.upper_bound(VirtualCode);it++){
			if(PushMouseButton(it->second)){
				return(true);
			}
		}
	}
	if(m_VBJBIS.find(VirtualCode)!=m_VBJBIS.end()){
		for(multimap<BYTE, pair<DWORD, BYTE> >::const_iterator it=m_VBJBIS.lower_bound(VirtualCode);it!=m_VBJBIS.upper_bound(VirtualCode);it++){
			if(PushJoyButton(it->second.second, it->second.first)){
				return(true);
			}
		}
	}
	if(m_VBJBLIS.find(VirtualCode)!=m_VBJBLIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBLIS.lower_bound(VirtualCode);it!=m_VBJBLIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Left && !m_JBIS[1-m_ISIT].at(it->second).Left){
				return(true);
			}
		}
	}
	if(m_VBJBRIS.find(VirtualCode)!=m_VBJBRIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBRIS.lower_bound(VirtualCode);it!=m_VBJBRIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Right && !m_JBIS[1-m_ISIT].at(it->second).Right){
				return(true);
			}
		}
	}
	if(m_VBJBUIS.find(VirtualCode)!=m_VBJBUIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBUIS.lower_bound(VirtualCode);it!=m_VBJBUIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Up && !m_JBIS[1-m_ISIT].at(it->second).Up){
				return(true);
			}
		}
	}
	if(m_VBJBDIS.find(VirtualCode)!=m_VBJBDIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBDIS.lower_bound(VirtualCode);it!=m_VBJBDIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && m_JBIS[m_ISIT].at(it->second).Down && !m_JBIS[1-m_ISIT].at(it->second).Down){
				return(true);
			}
		}
	}
	return(false);
}
//ꂽ΂肩H
bool DX9AInputHelper::PushUpVirtualButton(BYTE VirtualCode) const{
	if(m_VBKIS.find(VirtualCode)!=m_VBKIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBKIS.lower_bound(VirtualCode);it!=m_VBKIS.upper_bound(VirtualCode);it++){
			if(PushUpKey(it->second)){
				return(true);
			}
		}
	}
	if(m_VBMBIS.find(VirtualCode)!=m_VBMBIS.end()){
		for(multimap<BYTE, BYTE>::const_iterator it=m_VBMBIS.lower_bound(VirtualCode);it!=m_VBMBIS.upper_bound(VirtualCode);it++){
			if(PushUpMouseButton(it->second)){
				return(true);
			}
		}
	}
	if(m_VBJBIS.find(VirtualCode)!=m_VBJBIS.end()){
		for(multimap<BYTE, pair<DWORD, BYTE> >::const_iterator it=m_VBJBIS.lower_bound(VirtualCode);it!=m_VBJBIS.upper_bound(VirtualCode);it++){
			if(PushUpJoyButton(it->second.second, it->second.first)){
				return(true);
			}
		}
	}
	if(m_VBJBLIS.find(VirtualCode)!=m_VBJBLIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBLIS.lower_bound(VirtualCode);it!=m_VBJBLIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && !m_JBIS[m_ISIT].at(it->second).Left && m_JBIS[1-m_ISIT].at(it->second).Left){
				return(true);
			}
		}
	}
	if(m_VBJBRIS.find(VirtualCode)!=m_VBJBRIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBRIS.lower_bound(VirtualCode);it!=m_VBJBRIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && !m_JBIS[m_ISIT].at(it->second).Right && m_JBIS[1-m_ISIT].at(it->second).Right){
				return(true);
			}
		}
	}
	if(m_VBJBUIS.find(VirtualCode)!=m_VBJBUIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBUIS.lower_bound(VirtualCode);it!=m_VBJBUIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && !m_JBIS[m_ISIT].at(it->second).Up && m_JBIS[1-m_ISIT].at(it->second).Up){
				return(true);
			}
		}
	}
	if(m_VBJBDIS.find(VirtualCode)!=m_VBJBDIS.end()){
		for(multimap<BYTE, DWORD>::const_iterator it=m_VBJBDIS.lower_bound(VirtualCode);it!=m_VBJBDIS.upper_bound(VirtualCode);it++){
			if(it->second<m_JBIS[m_ISIT].size() && !m_JBIS[m_ISIT].at(it->second).Down && m_JBIS[1-m_ISIT].at(it->second).Down){
				return(true);
			}
		}
	}
	return(false);
}
//ꂩ̉z{^ꂽH
bool DX9AInputHelper::IsAnyVirtualButton() const{
	for(multimap<BYTE, BYTE>::const_iterator it=m_VBKIS.begin();it!=m_VBKIS.end();it++){
		if(Key(it->second)){
			return(true);
		}
	}
	for(multimap<BYTE, BYTE>::const_iterator it=m_VBMBIS.begin();it!=m_VBMBIS.end();it++){
		if(MouseButton(it->second)){
			return(true);
		}
	}
	for(multimap<BYTE, pair<DWORD, BYTE> >::const_iterator it=m_VBJBIS.begin();it!=m_VBJBIS.end();it++){
		if(JoyButton(it->second.second, it->second.first)){
			return(true);
		}
	}
	return(false);
}

//̑
//ꂩ̃{^ꂽH
bool DX9AInputHelper::IsAnyButton() const{
	return(IsAnyKey() || IsAnyMouseButton() || IsAnyJoyButton());
}

}
}
}