#include "stdafx.h"
#include "../index.h"
#include "IDraw2DHelper.h"

namespace nsDX9A{
namespace nsFramework{
namespace nsIDraw2DHelper{

//RXgN^
IDraw2DHelper::IDraw2DHelper(DX9AGraphic* GM, D3DCOLOR ColorKey, DX9AFilePack* FPM, const string& FilePackName){
	m_GM = GM;
	m_ColorKey = ColorKey;
	m_FPM = FPM;
	m_FilePackName = FilePackName;
}
//fXgN^
IDraw2DHelper::~IDraw2DHelper(){
	ReleaseAllDrawer();
}

//ێ`NXS
void IDraw2DHelper::ReleaseAllDrawer(){
	for(map<string, IDraw2D*>::iterator it=m_Drawers.begin();it!=m_Drawers.end();it++){
		SAFE_RELEASE(it->second);
	}
	m_Drawers.clear();
}
//ێ`NX
void IDraw2DHelper::ReleaseDrawer(const string& Alias){
	if(m_Drawers.find(Alias)!=m_Drawers.end()){
		SAFE_RELEASE(m_Drawers.find(Alias)->second);
		m_Drawers.erase(m_Drawers.find(Alias));
	}
}
//ێ`NX擾
IDraw2D* IDraw2DHelper::GetDrawer(const string& Alias){
	return(m_Drawers.find(Alias)!=m_Drawers.end() ? m_Drawers.find(Alias)->second : NULL);
}
//ێ`NXǉ
void IDraw2DHelper::CreateDrawer(const string& FileName, const string& Alias){
	if(m_Drawers.find(Alias)==m_Drawers.end()){
		m_Drawers.insert(pair<string, IDraw2D*>(Alias, new CDraw2D(m_GM, new CDraw2DReader(m_GM, m_FilePackName=="" ? new CFileReader : new CFilePackReader(m_FPM, m_FilePackName), FileName, m_ColorKey))));
	}
}

}
}
}