#include "stdafx.h"
#include "../index.h"
#include "Process.h"

namespace nsDX9A{
namespace nsFramework{
namespace nsProcess{

//RXgN^ivZXǗNXANXhcwj
CProcess::CProcess(DX9AProcess* Manager, int ClassID){
	m_Next = NULL;
	m_Parent = NULL;
	m_POnBegin = m_POnMove = m_POnDraw = m_POnEnd = 0;
	m_Manager = NULL;
	m_ClassID = ClassID;
	m_IsReleased = false;
	SetManager(Manager);
}

//
void CProcess::Release(){
	if(!m_IsReleased){
		SAFE_RELEASE(m_Next);
		if(m_Parent){
			m_Parent->UnregisterChild(this);
			m_Parent = NULL;
		}
		multimap<string, IProcess*> Temp = m_Children;
		for(multimap<string, IProcess*>::iterator it=Temp.begin();it!=Temp.end();it++){
			SAFE_RELEASE(it->second);
		}
		m_Children.clear();
		m_POnBegin = m_POnMove = m_POnDraw = m_POnEnd = 0;
		m_TLOnBegin.clear();
		m_TLOnMove.clear();
		m_TLOnDraw.clear();
		m_TLOnEnd.clear();
		m_IsReleased = true;
	}
}
//ς݂H
bool CProcess::IsReleased() const{
	return(m_IsReleased);
}

//NXhc擾
int CProcess::GetClassID() const{
	return(m_ClassID);
}

//vZX擾
IProcess* CProcess::GetNext(){
	return(m_Next);
}
//vZXݒ
IProcess* CProcess::SetNext(IProcess* Next){
	m_Next = Next;
	return(m_Next);
}
//vZXɐؑ
void CProcess::SwitchToNext(string NewTagName, bool IsInheritParent, bool IsInheritChild){
	m_Next->SetParent(NewTagName, IsInheritParent ? m_Parent : m_Manager->GetRootProcess());
	if(IsInheritChild){
		multimap<string, IProcess*> Temp = m_Children;
		for(multimap<string, IProcess*>::iterator it=Temp.begin();it!=Temp.end();it++){
			m_Next->RegisterChild(it->first, it->second);
		}
		m_Children.clear();
	}
	m_Next = NULL;
	Release();
}
	
//qvZX擾iOj
vector<IProcess*> CProcess::GetChildrenOnBegin(){
	return(m_TLOnBegin);
}
//qvZX擾i{j
vector<IProcess*> CProcess::GetChildrenOnMove(){
	return(m_TLOnMove);
}
//qvZX擾i`掞j
vector<IProcess*> CProcess::GetChildrenOnDraw(){
	return(m_TLOnDraw);
}
//qvZX擾i㏈j
vector<IProcess*> CProcess::GetChildrenOnEnd(){
	return(m_TLOnEnd);
}
//qvZX擾
multimap<string, IProcess*> CProcess::GetChildren(){
	return(m_Children);
}
//qvZXo^
void CProcess::RegisterChild(string TagName, IProcess* Child){
	//֐pNX
	class InnerFunction{
	public:
		//sDxr֐(1)
		static bool CompareOnBegin(const IProcess* P1, const IProcess* P2){
			return(((const CProcess*)(P1))->m_POnBegin<((const CProcess*)(P2))->m_POnBegin);
		}
		//sDxr֐(2)
		static bool CompareOnMove(const IProcess* P1, const IProcess* P2){
			return(((const CProcess*)(P1))->m_POnMove<((const CProcess*)(P2))->m_POnMove);
		}
		//sDxr֐(3)
		static bool CompareOnDraw(const IProcess* P1, const IProcess* P2){
			return(((const CProcess*)(P1))->m_POnDraw<((const CProcess*)(P2))->m_POnDraw);
		}
		//sDxr֐(4)
		static bool CompareOnEnd(const IProcess* P1, const IProcess* P2){
			return(((const CProcess*)(P1))->m_POnEnd<((const CProcess*)(P2))->m_POnEnd);
		}
	};
	for(multimap<string, IProcess*>::iterator it=m_Children.begin();it!=m_Children.end();it++){
		if(it->second==Child){
			return;
		}
	}
	m_Children.insert(pair<string, IProcess*>(TagName, Child));
	m_TLOnBegin.push_back(Child);
	m_TLOnMove.push_back(Child);
	m_TLOnDraw.push_back(Child);
	m_TLOnEnd.push_back(Child);
	sort<vector<IProcess*>::iterator>(m_TLOnBegin.begin(), m_TLOnBegin.end(), InnerFunction::CompareOnBegin);
	sort<vector<IProcess*>::iterator>(m_TLOnMove.begin(), m_TLOnMove.end(), InnerFunction::CompareOnMove);
	sort<vector<IProcess*>::iterator>(m_TLOnDraw.begin(), m_TLOnDraw.end(), InnerFunction::CompareOnDraw);
	sort<vector<IProcess*>::iterator>(m_TLOnEnd.begin(), m_TLOnEnd.end(), InnerFunction::CompareOnEnd);
	Child->SetParent(TagName, this);
}
//qvZXo^i^OŎwj
void CProcess::UnregisterChild(string TagName){
	if(m_Children.find(TagName)!=m_Children.end()){
		for(multimap<string, IProcess*>::iterator it=m_Children.lower_bound(TagName);it!=m_Children.upper_bound(TagName);it++){
			m_TLOnBegin.erase(find<vector<IProcess*>::iterator>(m_TLOnBegin.begin(), m_TLOnBegin.end(), it->second));
			m_TLOnMove.erase(find<vector<IProcess*>::iterator>(m_TLOnMove.begin(), m_TLOnMove.end(), it->second));
			m_TLOnDraw.erase(find<vector<IProcess*>::iterator>(m_TLOnDraw.begin(), m_TLOnDraw.end(), it->second));
			m_TLOnEnd.erase(find<vector<IProcess*>::iterator>(m_TLOnEnd.begin(), m_TLOnEnd.end(), it->second));
			((CProcess*)(it->second))->m_Parent = NULL;
		}
		m_Children.erase(m_Children.lower_bound(TagName), m_Children.upper_bound(TagName));
	}
}
//qvZXo^i|C^Ŏwj
void CProcess::UnregisterChild(IProcess* Child){
	for(multimap<string, IProcess*>::iterator it=m_Children.begin();it!=m_Children.end();it++){
		if(it->second==Child){
			m_TLOnBegin.erase(find<vector<IProcess*>::iterator>(m_TLOnBegin.begin(), m_TLOnBegin.end(), it->second));
			m_TLOnMove.erase(find<vector<IProcess*>::iterator>(m_TLOnMove.begin(), m_TLOnMove.end(), it->second));
			m_TLOnDraw.erase(find<vector<IProcess*>::iterator>(m_TLOnDraw.begin(), m_TLOnDraw.end(), it->second));
			m_TLOnEnd.erase(find<vector<IProcess*>::iterator>(m_TLOnEnd.begin(), m_TLOnEnd.end(), it->second));
			((CProcess*)(it->second))->m_Parent = NULL;
			m_Children.erase(it);
			return;
		}
	}
}

//evZX擾
IProcess* CProcess::GetParent(){
	return(m_Parent);
}
//evZXݒ
void CProcess::SetParent(string NewTagNameMine, IProcess* Parent){
	if(m_Parent==Parent){
		return;
	}
	if(m_Parent){
		m_Parent->UnregisterChild(this);
	}
	m_Parent = Parent;
	if(m_Parent){
		m_Parent->RegisterChild(NewTagNameMine, this);
	}
}

//vZXǗNX擾
DX9AProcess* CProcess::GetManager(){
	return(m_Manager);
}
//vZXǗNXݒ
void CProcess::SetManager(DX9AProcess* Manager){
	if(m_Manager==Manager){
		return;
	}
	if(m_Manager){
		m_Manager->UnregisterFromProcessPool(this);
	}
	m_Manager = Manager;
	if(m_Manager){
		m_Manager->RegisterToProcessPool(this);
	}
}

//sDxݒ
void CProcess::SetPriority(int OnBegin, int OnMove, int OnDraw, int OnEnd){
	m_POnBegin = OnBegin;
	m_POnMove = OnMove;
	m_POnDraw = OnDraw;
	m_POnEnd = OnEnd;
}
//sDx擾
void CProcess::GetPriority(int& OnBegin, int& OnMove, int& OnDraw, int& OnEnd) const{
	OnBegin = m_POnBegin;
	OnMove = m_POnMove;
	OnDraw = m_POnDraw;
	OnEnd = m_POnEnd;
}



//ftHgRXgN^
CRootProcess::CRootProcess() : CProcess(NULL, INT_MAX) {
	m_IsPause = false;
}

//
void CRootProcess::Init(){
	multimap<string, IProcess*> Temp = m_Children;
	for(multimap<string, IProcess*>::iterator it=Temp.begin();it!=Temp.end();it++){
		SAFE_RELEASE(it->second);
	}
	m_Children.clear();
	m_TLOnBegin.clear();
	m_TLOnMove.clear();
	m_TLOnDraw.clear();
	m_TLOnEnd.clear();
	m_IsPause = false;
}

//vZXsiOj
void CRootProcess::OnBegin(){
	m_TempList = m_TLOnBegin;
	for(vector<IProcess*>::iterator it=m_TempList.begin();it!=m_TempList.end();it++){
		(*it)->OnBegin();
	}
}
//vZXsi{j
void CRootProcess::OnMove(){
	m_TempList = m_TLOnMove;
	for(vector<IProcess*>::iterator it=m_TempList.begin();it!=m_TempList.end();it++){
		(*it)->OnMove();
	}
}
//vZXsi`j
void CRootProcess::OnDraw(){
	m_TempList = m_TLOnDraw;
	for(vector<IProcess*>::iterator it=m_TempList.begin();it!=m_TempList.end();it++){
		(*it)->OnDraw();
	}
}
//vZXsi㏈j
void CRootProcess::OnEnd(){
	m_TempList = m_TLOnEnd;
	for(vector<IProcess*>::iterator it=m_TempList.begin();it!=m_TempList.end();it++){
		(*it)->OnEnd();
	}
}

//|[Y
void CRootProcess::Pause(){
	if(!m_IsPause){
		multimap<string, IProcess*> Temp = m_Children;
		for(multimap<string, IProcess*>::iterator it=Temp.begin();it!=Temp.end();it++){
			it->second->Pause();
		}
		m_IsPause = true;
	}
}
//|[Y
void CRootProcess::Restart(){
	if(m_IsPause){
		multimap<string, IProcess*> Temp = m_Children;
		for(multimap<string, IProcess*>::iterator it=Temp.begin();it!=Temp.end();it++){
			it->second->Restart();
		}
		m_IsPause = false;
	}
}
//|[YԂH
bool CRootProcess::IsPause() const{
	return(m_IsPause);
}



//fXgN^
DX9AProcess::~DX9AProcess(){
	for(multimap<int, IProcess*>::iterator it=m_ProcessPool.begin();it!=m_ProcessPool.end();it++){
		delete((CProcess*)(it->second));
	}
}
	
//
void DX9AProcess::Init(){
	m_RootProcess.Init();
}

//vZXsiOj
void DX9AProcess::OnBegin(){
	m_RootProcess.OnBegin();
}
//vZXsi{j
void DX9AProcess::OnMove(){
	m_RootProcess.OnMove();
}
//vZXsi`j
void DX9AProcess::OnDraw(){
	m_RootProcess.OnDraw();
}
//vZXsi㏈j
void DX9AProcess::OnEnd(){
	m_RootProcess.OnEnd();
}

//|[Y
void DX9AProcess::Pause(){
	m_RootProcess.Pause();
}
//|[Y
void DX9AProcess::Restart(){
	m_RootProcess.Restart();
}
//|[YԂH
bool DX9AProcess::IsPause() const{
	return(m_RootProcess.IsPause());
}

//ŏʃvZX擾
CRootProcess* DX9AProcess::GetRootProcess(){
	return(&m_RootProcess);
}
//vZXŏʃvZXɓo^
void DX9AProcess::RegisterToRootProcess(string TagName, IProcess* Process){
	m_RootProcess.RegisterChild(TagName, Process);
}
//vZXŏʃvZXo^i^OŎwj
void DX9AProcess::UnregisterFromRootProcess(string TagName){
	m_RootProcess.UnregisterChild(TagName);
}
//vZXŏʃvZXo^i|C^Ŏwj
void DX9AProcess::UnregisterFromRootProcess(IProcess* Process){
	m_RootProcess.UnregisterChild(Process);
}

//vZXvZXv[擾
IProcess* DX9AProcess::GetFromProcessPool(int ProcessType){
	if(m_ProcessPool.find(ProcessType)!=m_ProcessPool.end()){
		for(multimap<int, IProcess*>::iterator it=m_ProcessPool.lower_bound(ProcessType);it!=m_ProcessPool.upper_bound(ProcessType);it++){
			if(it->second->IsReleased()){
				((CProcess*)(it->second))->m_IsReleased = false;
				it->second->Init();
				return(it->second);
			}
		}
	}
	return(NULL);
}
//vZXvZXv[ɓo^
void DX9AProcess::RegisterToProcessPool(IProcess* Process){
	for(multimap<int, IProcess*>::iterator it=m_ProcessPool.begin();it!=m_ProcessPool.end();it++){
		if(it->second==Process){
			return;
		}
	}
	m_ProcessPool.insert(pair<int, IProcess*>(Process->GetClassID(), Process));
	Process->SetManager(this);
}
//vZXvZXv[o^
void DX9AProcess::UnregisterFromProcessPool(IProcess* Process){
	for(multimap<int, IProcess*>::iterator it=m_ProcessPool.begin();it!=m_ProcessPool.end();it++){
		if(it->second==Process){
			((CProcess*)(it->second))->m_Manager = NULL;
			m_ProcessPool.erase(it);
			return;
		}
	}
}

}
}
}