#include "stdafx.h"
#include "../index.h"
#include "Scene.h"

namespace nsDX9A{
namespace nsFramework{
namespace nsScene{

//RXgN^iV[NXAV[wj
DX9AScene::DX9AScene(ISceneFactory* isf, int eScene){
	m_SceneFactory = isf ? isf : new CNullSceneFactory;
	PushScene(eScene);
}
//fXgN^
DX9AScene::~DX9AScene(){
	SAFE_RELEASE(m_SceneFactory);
	for(vector<IScene*>::iterator it=m_SceneStack.begin();it!=m_SceneStack.end();it++){
		SAFE_RELEASE(*it);
	}
}

//V[vbV
void DX9AScene::PushScene(int eScene){
	m_SceneStack.push_back(eScene>=0 ? m_SceneFactory->CreateScene(eScene) : new CNullScene);
}
//V[ړigotoj
void DX9AScene::JumpScene(int eScene){
	m_Message.push_back(1);
	m_NextScene.push_back(eScene);
}
//V[ړigosubAĂяo͏j
void DX9AScene::CallScene(int eScene){
	m_Message.push_back(2);
	m_NextScene.push_back(eScene);
}
//V[ړigosubAĂяo͏Ȃj
void DX9AScene::CallSceneFast(int eScene){
	m_Message.push_back(3);
	m_NextScene.push_back(eScene);
}
//V[ړireturnj
void DX9AScene::ReturnScene(){
	m_Message.push_back(4);
	m_NextScene.push_back(-1);
}

//V[s
void DX9AScene::Run(){
	if(IsEnd()){
		DX9AErrOut("DX9AScene::Run No Scene\n");
	}
	else{
		m_SceneStack.back()->OnBegin();
		m_SceneStack.back()->OnMove();
		m_SceneStack.back()->OnDraw(true);
		m_SceneStack.back()->OnEnd();
		for(unsigned int i=0;i<m_Message.size();i++){
			switch(m_Message[i]){
				case(1):
					PopScene();
					PushScene(m_NextScene[i]);
					break;
				case(2):
					GetCurrentScene()->Init();
					PushScene(m_NextScene[i]);
					break;
				case(3):
					PushScene(m_NextScene[i]);
					break;
				case(4):
					PopScene();
					break;
			}
		}
		m_Message.clear();
		m_NextScene.clear();
	}
}

//V[NXݒ
void DX9AScene::SetSceneFactory(ISceneFactory* SceneFactory){
	SAFE_RELEASE(m_SceneFactory);
	m_SceneFactory = SceneFactory ? SceneFactory : new CNullSceneFactory;
}
//V[NX擾
ISceneFactory* DX9AScene::GetSceneFactory(){
	return(m_SceneFactory);
}

//IԁiV[X^bNorV[kfoCXjH
bool DX9AScene::IsEnd(){
	return(m_SceneStack.empty() || GetCurrentScene()->GetID()<0);
}

//V[̃NX擾
IScene* DX9AScene::GetCurrentScene(){
	return(GetPreviousScene(0));
}
//OV[̃NX擾
IScene* DX9AScene::GetPreviousScene(unsigned int NumPrev){
	return(m_SceneStack[m_SceneStack.size()-(NumPrev+1)]);
}

//V[|bv
void DX9AScene::PopScene(){
	SAFE_RELEASE(m_SceneStack.back());
	m_SceneStack.pop_back();
}

}
}
}