#include "stdafx.h"
#include "../index.h"
#include "Sprite.h"

namespace nsDX9A{
namespace nsFramework{
namespace nsSprite{

//RXgN^
cSprite::cSprite(DX9AGraphic* GM, DX9AParam* PM, IDraw2DHelper* Helper){
	m_GM = GM;
	m_PM = PM;
	m_AnimDrawer = Helper;
	m_WaitTime = 16;
	m_AnimationNo = 0;
	m_UpdateType = 0;
	m_IsLoop = false;
	m_BaseScaling = 1.0f;
}

//p[^ݒiڎwj
void cSprite::SetParam(const vector< pair<string, RECT> >& AnimPattern, float BaseScaling, DWORD WaitTime){
	m_AnimPattern = AnimPattern;
	for(vector< pair<string, RECT> >::iterator it=m_AnimPattern.begin();it!=m_AnimPattern.end();it++){
		m_AnimDrawer->CreateDrawer(it->first, it->first);
	}
	m_BaseScaling = BaseScaling;
	m_WaitTime = WaitTime;
}
//p[^ݒiݒt@Cwj
void cSprite::SetParam(const string& INIFileName){
	m_AnimPattern.clear();
	string TempF;
	RECT TempS;
	char SectionName[1024];
	int AnimPatternNum = m_PM->GetIntParam(INIFileName, "Animations", "AnimationNum", 0);
	m_BaseScaling = static_cast<float>(m_PM->GetIntParam(INIFileName, "Animations", "BaseScaling", 100)) / 100;
	m_WaitTime = m_PM->GetIntParam(INIFileName, "Animations", "WaitTime", 16);
	for(int i=0;i<AnimPatternNum;i++){
		sprintf(SectionName, "Animation%d", i);
		TempF = m_PM->GetStrParam(INIFileName, SectionName, "AnimationFileName", "");
		TempS.left = m_PM->GetIntParam(INIFileName, SectionName, "AnimationSrcRect_Left", 0);
		TempS.top = m_PM->GetIntParam(INIFileName, SectionName, "AnimationSrcRect_Top", 0);
		TempS.right = m_PM->GetIntParam(INIFileName, SectionName, "AnimationSrcRect_Right", 0);
		TempS.bottom = m_PM->GetIntParam(INIFileName, SectionName, "AnimationSrcRect_Bottom", 0);
		m_AnimPattern.push_back(pair<string, RECT>(TempF, TempS));
		m_AnimDrawer->CreateDrawer(TempF, TempF);
	}
}

//`
void cSprite::OnDraw(int X, int Y, bool IsCenter, float NowScaling, float Degree){
	int AnimationNo = m_AnimationNo;
	if(AnimationNo<0){
		AnimationNo = 0;
	}
	if(AnimationNo>=static_cast<int>(m_AnimPattern.size())){
		AnimationNo = static_cast<int>(m_AnimPattern.size()) - 1;
	}
	m_AnimDrawer->GetDrawer(m_AnimPattern.at(AnimationNo).first)->Blt(IsCenter ? X-static_cast<int>(static_cast<float>(m_AnimPattern.at(AnimationNo).second.right-m_AnimPattern.at(AnimationNo).second.left)/2.0f*m_BaseScaling*NowScaling) : X, 
																	  IsCenter ? Y-static_cast<int>(static_cast<float>(m_AnimPattern.at(AnimationNo).second.bottom-m_AnimPattern.at(AnimationNo).second.top)/2.0f*m_BaseScaling*NowScaling) : Y, 
																	  255, &(m_AnimPattern.at(AnimationNo).second), m_BaseScaling*NowScaling, m_BaseScaling*NowScaling, Degree);
}
//XV
void cSprite::Update(){
	m_Timer.Flush();
	if(!m_Timer.IsPause() && m_Timer.Get()>m_WaitTime){
		if(m_UpdateType){
			m_AnimationNo += (m_UpdateType / abs(m_UpdateType));
			if(m_IsLoop){
				if(m_AnimationNo<0){
					m_AnimationNo = static_cast<int>(m_AnimPattern.size()) - 1;
				}
				if(m_AnimationNo>=static_cast<int>(m_AnimPattern.size())){
					m_AnimationNo = 0;
				}
			}
		}
		m_Timer.Reset();
	}
}
//`NX擾
pair<IDraw2D*, RECT> cSprite::GetDrawer() const{
	return(pair<IDraw2D*, RECT>(m_AnimDrawer->GetDrawer(m_AnimPattern.at(m_AnimationNo).first), m_AnimPattern.at(m_AnimationNo).second));
}

//Aj[Vԍ擾
unsigned int cSprite::GetAnimationNo() const{
	return(m_AnimationNo);
}
//Aj[Vԍݒ
void cSprite::SetAnimationNo(unsigned int AnimationNo){
	m_Timer.Reset();
	m_AnimationNo = AnimationNo;
}

//XV̎ނ擾
int cSprite::GetUpdateType() const{
	return(m_UpdateType);
}
//XV̎ނݒ
void cSprite::SetUpdateType(int Type){
	m_UpdateType = Type;
}

//XVI擾
bool cSprite::IsEnd() const{
	return(!m_IsLoop && (m_AnimationNo<0 || m_AnimationNo>=static_cast<int>(m_AnimPattern.size())));
}

//[v邩擾
bool cSprite::GetIsLoop() const{
	return(m_IsLoop);
}
//[vĂ邩ݒ
void cSprite::SetIsLoop(bool IsLoop){
	m_IsLoop = IsLoop;
}

//|[Y
void cSprite::Pause(){
	m_Timer.Pause();
}
//|[Y
void cSprite::Restart(){
	m_Timer.Restart();
}
//|[YԂH
bool cSprite::IsPause() const{
	return(m_Timer.IsPause());
}

}
}
}