#include "stdafx.h"
#include "../index.h"
#include "DX9AGraphic.h"

namespace nsDX9A{
namespace nsGraphics{
namespace nsDX9AGraphic{

//ftHgRXgN^
DX9AGraphic::DX9AGraphic(){
	m_hWnd = NULL;
	m_hInst = NULL;
	m_IsActive = false;
	m_IsBeginScene = false;
	m_IsBeginSprite = false;
	m_IsDeviceLost = false;
	m_ScreenWidth = 0;
	m_ScreenHeight = 0;
	m_IsFullScreen = false;
	m_IsUseDepthStencil = false;
	m_IsUseMultiSample = false;
	ZeroMemory(&m_WindowLastPos, sizeof(m_WindowLastPos));

	m_pD3D = NULL;
	m_pD3DDevice = NULL;
	ZeroMemory(&m_D3DParamNow, sizeof(m_D3DParamNow));
	ZeroMemory(&m_D3DParamWin, sizeof(m_D3DParamWin));
	ZeroMemory(&m_D3DParamFull, sizeof(m_D3DParamFull));
	m_FmtRenderTextureWin = D3DFMT_UNKNOWN;
	m_FmtRenderTextureFull = D3DFMT_UNKNOWN;

	m_pD3DXSprite = NULL;
	m_pDrawRect = NULL;

	m_StringTextureNowSize = 0;
	m_StringTextureMaxSize = 0;
}
//fXgN^
DX9AGraphic::~DX9AGraphic(){
	CleanupApp();
}

//iKs邱Ɓj
bool DX9AGraphic::Init(HINSTANCE hInst, LPCTSTR WindowName, WNDPROC WndProc, int ScreenWidth, int ScreenHeight, unsigned int StringTextureMaxSize, 
					   bool IsFullScreen, bool UseDepthStencil, bool UseMultiSample, HICON hIcon, HCURSOR hCursor, HICON hIconSm){

	if(m_hInst){
		DX9AErrOut("Failed : DX9AGraphic::Init Already Initialized\n");
		return(false);
	}

	//oϐ
	m_hInst = hInst;
	m_ClassName = WindowName;
	m_ScreenWidth = ScreenWidth;
	m_ScreenHeight = ScreenHeight;
	m_IsFullScreen = IsFullScreen;
	m_IsUseDepthStencil = UseDepthStencil;
	m_IsUseMultiSample = UseMultiSample;
	m_WindowLastPos.top = 0;
	m_WindowLastPos.left = 0;
	m_WindowLastPos.right = ScreenWidth;
	m_WindowLastPos.bottom = ScreenHeight;
	m_StringTextureMaxSize = StringTextureMaxSize;

	//AvP[V
	if(!InitApp(WindowName, WndProc, hIcon, hCursor, hIconSm)){
		DX9AErrOut("Failed : DX9AGraphic::Init InitApp\n");
		return(false);
	}

	//Direct3DɊǗĂIuWFNg
	if(!InitD3D()){
		DX9AErrOut("Failed : DX9AGraphic::Init InitD3D\n");
		return(false);
	}

	return(true);
}

//ACh̏iKs邱Ɓj
bool DX9AGraphic::AppIdle(){

	if(!m_pD3D || !m_pD3DDevice){
		DX9AErrOut(m_pD3D ? "Failed : DX9AGraphic::AppIdle No D3DDevice\n" : "Failed : DX9AGraphic::AppIdle No D3D\n");
		return(false);
	}

	if(!m_IsActive){
		return(true);
	}

	//foCX̕
	HRESULT hr;
	if(m_IsDeviceLost){

		//foCXԂ`FbN
		hr = m_pD3DDevice->TestCooperativeLevel();
		if(FAILED(hr)){

			if(hr==D3DERR_DEVICELOST){
				return(true);			//܂Ă
			}
			if(hr!=D3DERR_DEVICENOTRESET){
				DX9AErrOut("Failed : DX9AGraphic::AppIdle Unknown Error\n");
				return(false);			//\ʃG[
			}

			//Direct3DɊǗĂȂIuWFNgJ
			CleanupD3DObject();

			//݂
			hr = m_pD3DDevice->Reset(&m_D3DParamNow);
			if(FAILED(hr)){
				if(hr==D3DERR_DEVICELOST){
					return(true);		//܂Ă
				}
				else{
					DX9AErrOut("Failed : DX9AGraphic::AppIdle Reset\n");
					return(false);		//Ɏs
				}
			}

			//Direct3DɊǗĂȂIuWFNgĎ擾
			if(!InitD3DObject()){
				DX9AErrOut("Failed : DX9AGraphic::AppIdle InitD3DObject\n");
				return(false);
			}

		}

		//ɐ
		m_IsDeviceLost = false;

	}

	//`FbN
	hr = m_pD3DDevice->TestCooperativeLevel();
	if(FAILED(hr)){
		if(hr==D3DERR_DEVICELOST || hr==D3DERR_DEVICENOTRESET){
			m_IsDeviceLost = true;
		}
		else{
			DX9AErrOut("Failed : DX9AGraphic::AppIdle TestCooperativeLevel Failed\n");
			return(false);
		}
	}
	else{
		//eNX`̊Ǘ
		DWORD Now = timeGetTime();
		map<string, StringTexture>::iterator it;
		while(m_StringTextureNowSize>m_StringTextureMaxSize){
			it = m_StringTexture.begin();
			for(map<string, StringTexture>::iterator it2=m_StringTexture.begin();it2!=m_StringTexture.end();it2++){
				if(Now-it2->second.LastRefTime>Now-it->second.LastRefTime){
					it = it2;
				}
				if(Now-it2->second.LastRefTime==Now-it->second.LastRefTime){
					if(it2->second.Size>it->second.Size){
						it = it2;
					}
				}
			}
			m_StringTextureNowSize -= it->second.Size;
			SAFE_RELEASE(it->second.Texture);
			m_StringTexture.erase(it);
		}
	}
	return(true);
}

//EChEvV[WiKĂяoƁj
void DX9AGraphic::MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch(uMsg){
		case(WM_ACTIVATE):
			m_IsActive = (LOWORD(wParam)!=0);
			break;
		case(WM_DESTROY):
			CleanupD3DObject();
			CleanupD3D();
			break;
	}
	UNREFERENCED_PARAMETER(hWnd);
	UNREFERENCED_PARAMETER(lParam);
}

//̑iς܂ĂĂяoƁj

//ANeBuԂ擾
bool DX9AGraphic::IsActive() const{
	return(m_IsActive);
}

//EChEnh擾
HWND DX9AGraphic::GetHWND() const{
	return(m_hWnd);
}

//ʂ̉擾
int DX9AGraphic::GetScreenWidth() const{
	return(m_ScreenWidth);
}
//ʂ̏c擾
int DX9AGraphic::GetScreenHeight() const{
	return(m_ScreenHeight);
}
//tXN[[hۂ擾
bool DX9AGraphic::GetFullScreen() const{
	return(m_IsFullScreen);
}
//tXN[[hۂݒ
bool DX9AGraphic::SetFullScreen(bool IsFullScreen){
	if(m_IsFullScreen!=IsFullScreen){

		m_IsFullScreen = IsFullScreen;

		CleanupD3DObject();

		if(m_IsFullScreen){
			m_D3DParamNow = m_D3DParamFull;
			GetWindowRect(m_hWnd, &m_WindowLastPos);
		}
		else{
			m_D3DParamNow = m_D3DParamWin;
		}

		HRESULT hr = m_pD3DDevice->Reset(&m_D3DParamNow);
		if(FAILED(hr)){
			if(hr==D3DERR_DEVICELOST){
				m_IsDeviceLost = true;
			}
			else{
				DestroyWindow(m_hWnd);
			}
			DX9AErrOut("Failed : DX9AGraphic::SetFullScreen() Reset\n");
			return(false);
		}

		if(!InitD3DObject()){
			DX9AErrOut("Failed : DX9AGraphic::SetFullScreen() InitD3DObject\n");
			DestroyWindow(m_hWnd);
			return(false);
		}

		if(m_IsFullScreen){
			SetWindowLong(m_hWnd, GWL_STYLE, WS_POPUP | WS_VISIBLE);
		}
		else{
			SetWindowLong(m_hWnd, GWL_STYLE, WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE);
			SetWindowPos(m_hWnd, HWND_NOTOPMOST, m_WindowLastPos.left, m_WindowLastPos.top, 
						 m_WindowLastPos.right - m_WindowLastPos.left, m_WindowLastPos.bottom - m_WindowLastPos.top, SWP_SHOWWINDOW);
		}

	}
	return(true);
}

//ʂ
void DX9AGraphic::Clear(D3DCOLOR Color){
	m_pD3DDevice->Clear(0, NULL, m_IsUseDepthStencil ? D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL : D3DCLEAR_TARGET, Color, 1.0f, 0);
}

//ʂXV
void DX9AGraphic::Present(){
	EndSprite();
	EndScene();
	m_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}

//``
void DX9AGraphic::DrawRect(RECT Rect, D3DCOLOR Color, float Degree, D3DBLENDOP BlendOp, D3DBLEND SrcBlend, D3DBLEND DestBlend){
	RECT SrcRect = {0, 0, 1, 1};
	float ScalingX = static_cast<float>(Rect.right-Rect.left);
	float ScalingY = static_cast<float>(Rect.bottom-Rect.top);
	GeneralBlt(m_pDrawRect, Rect.left, Rect.top, Color, &SrcRect, BlendOp, SrcBlend, DestBlend, ScalingX, ScalingY, Degree);
}
//`
void DX9AGraphic::DrawFreeText(const string& Text, int x, int y, D3DCOLOR Color, const string& Font, unsigned int Size, bool IsBold, bool IsItalic, float Degree, D3DBLENDOP BlendOp, D3DBLEND SrcBlend, D3DBLEND DestBlend){
	//֐pNX
	class InnerFunction{
	public:
		//GetGlyphOutlinepɃGR[h
		static void EncodeText(const string& Src, wstring& Dest){
			Dest.clear();
			for(unsigned int i=0;Src[i]!='\0';){
				unsigned int ChByte = ((Src[i]>=static_cast<char>(0x81) && Src[i]<=static_cast<char>(0x9F)) || 
									  (Src[i]>=static_cast<char>(0xE0) && Src[i]<=static_cast<char>(0xFF))) ? 2 : 1;
				Dest.push_back(ChByte==2 ? static_cast<BYTE>(Src[i]) * 256 + static_cast<BYTE>(Src[i+1]) : static_cast<BYTE>(Src[i]));
				i += ChByte;
			}
		}
		//_aRs[
		static void* memcpy_or(void* s1, const void* s2, size_t n){
			register BYTE* ss1;
			register const BYTE* ss2;
			for(ss1=reinterpret_cast<BYTE*>(s1), ss2=reinterpret_cast<const BYTE*>(s2);n!=0;n--){
				*ss1++ |= *ss2++;
			}
			return(s1);
		}
	};

	//󕶎̏ꍇ
	if(Text==""){
		return;
	}
	//󕶎łȂꍇ
	else{
		//eLXgi`掞ɗpj𐶐
		char KeyText[1024] = {0};
		sprintf(KeyText, "%s_%s_%d_%d", Text.c_str(), Font.c_str(), Size, (IsBold ? 1 : 0)+(IsItalic ? 2 : 0));

		//GetGlyphOutlinepɃGR[h
		wstring Text2;
		InnerFunction::EncodeText(Text, Text2);

		//eNX`݂Ȃꍇ͍쐬
		if(m_StringTexture.find(KeyText)==m_StringTexture.end()){

			//tHg̍쐬
			LOGFONT LF = {Size, 0, 0, 0, (IsBold ? FW_BOLD : 0), (IsItalic ? TRUE : FALSE), 0, 0,
						  SHIFTJIS_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, ""};
			strcpy(LF.lfFaceName, Font.c_str());
			HFONT hFont;
			if((hFont = CreateFontIndirect(&LF))==0){
				DX9AErrOut("Failed : DX9AGraphic::DrawFreeText() CreateFontIndirect\n");
				return;
			}

			//foCXReLXg擾
			HDC hDC = GetDC(NULL);
			HFONT OldFont = reinterpret_cast<HFONT>(SelectObject(hDC, hFont));

			//eNX`̃TCY擾m
			TEXTMETRIC TM;
			GLYPHMETRICS GM;
			UINT TexWidth = 0, TexHeight = 0;
			CONST MAT2 Mat = {{0, 1}, {0, 0}, {0, 0}, {0, 1}};
			GetTextMetrics(hDC, &TM);
			TexHeight += TM.tmHeight;
			for(unsigned int i=0;Text2[i]!=L'\0';i++){
				if(Text2[i]==L'\n'){
					TexHeight += TM.tmHeight;
				}
				else{
					GetGlyphOutline(hDC, Text2[i], GGO_METRICS, &GM, 0, NULL, &Mat);
					TexWidth += GM.gmCellIncX;
				}
			}
			if(IsItalic){
				TexWidth += Size / 4;
			}
			unsigned int cnt;
			UINT TmpTexWidth = TexWidth, TmpTexHeight = TexHeight;
			for(cnt=0;pow(2.0f, static_cast<float>(cnt))<TexWidth;cnt++);	TexWidth = static_cast<UINT>(pow(2.0f, static_cast<float>(cnt)));
			for(cnt=0;pow(2.0f, static_cast<float>(cnt))<TexHeight;cnt++);	TexHeight = static_cast<UINT>(pow(2.0f, static_cast<float>(cnt)));
			m_StringTexture.insert(pair<string, StringTexture>(KeyText, StringTexture()));
			if(FAILED(D3DXCreateTexture(m_pD3DDevice, TexWidth, TexHeight, 1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &(m_StringTexture.find(KeyText)->second.Texture)))){
				DX9AErrOut("Failed : DX9AGraphic::DrawFreeText() D3DXCreateTexture\n");
				SelectObject(hDC, OldFont);
				DeleteObject(hFont);
				ReleaseDC(NULL, hDC);
				return;
			}

			//tHgrbg}bv擾eNX`ɏ
			DWORD Alpha, Color;
			D3DLOCKED_RECT LockedRect;
			BYTE* p = new BYTE[4 * TexWidth * TexHeight];
			int Base_X = 0, Base_Y = 0, Bmp_W, Bmp_H, Ofs_X, Ofs_Y;
			if(FAILED(m_StringTexture.find(KeyText)->second.Texture->LockRect(0, &LockedRect, NULL, D3DLOCK_DISCARD))){
				DX9AErrOut("Failed : DX9AGraphic::DrawFreeText() LockRect\n");
				SelectObject(hDC, OldFont);
				DeleteObject(hFont);
				ReleaseDC(NULL, hDC);
				SAFE_DELETE_ARRAY(p);
				return;
			}
			FillMemory(LockedRect.pBits , LockedRect.Pitch * TexHeight, 0);
			for(unsigned int i=0;Text2[i]!=L'\0';i++){
				if(Text2[i]==L'\n'){
					Base_X = 0;
					Base_Y += TM.tmHeight;
				}
				else{
					GetGlyphOutline(hDC, Text2[i], GGO_METRICS, &GM, 0, NULL, &Mat);
					if(Text2[i]!=32/* pXy[X */ && Text2[i]!=33088/* SpXy[X */){
						GetGlyphOutline(hDC, Text2[i], GGO_GRAY8_BITMAP, &GM, 4 * TexWidth * TexHeight, p, &Mat);
						Bmp_W = GM.gmBlackBoxX + (4 - (GM.gmBlackBoxX % 4)) % 4;
						Bmp_H = GM.gmBlackBoxY;
						Ofs_X = GM.gmptGlyphOrigin.x;
						Ofs_Y = TM.tmAscent - GM.gmptGlyphOrigin.y;
						for(int Y=0;Y<static_cast<int>(GM.gmBlackBoxY);Y++){
							for(int X=0;X<static_cast<int>(GM.gmBlackBoxX);X++){
								Alpha = (255 * p[Bmp_W * Y + X]) / 64;
								Color = 0x00ffffff | (Alpha << 24);
								InnerFunction::memcpy_or((BYTE*)LockedRect.pBits+LockedRect.Pitch*(Base_Y+Ofs_Y+Y)+4*(Base_X+Ofs_X+X), &Color, sizeof(Color)); 
							}
						}
					}
					Base_X += GM.gmCellIncX;
				}
			}
			m_StringTexture.find(KeyText)->second.Texture->UnlockRect(0);
			SAFE_DELETE_ARRAY(p);

			//eNX`̏ݒ
			m_StringTexture.find(KeyText)->second.Size = 4 * TexWidth * TexHeight;
			m_StringTexture.find(KeyText)->second.Width = TmpTexWidth;
			m_StringTexture.find(KeyText)->second.Height = TmpTexHeight;

			//eNX`̃TCY>eNX`̍őTCYȂAeNX`̍őTCYg
			if(m_StringTexture.find(KeyText)->second.Size>m_StringTextureMaxSize){
				m_StringTextureMaxSize = m_StringTexture.find(KeyText)->second.Size;
			}

			//eNX`̍vTCY𑝉
			m_StringTextureNowSize += m_StringTexture.find(KeyText)->second.Size;

			//n
			SelectObject(hDC, OldFont);
			DeleteObject(hFont);
			ReleaseDC(NULL, hDC);

		}

		//`
		RECT SrcRect = {0, 0, m_StringTexture.find(KeyText)->second.Width, m_StringTexture.find(KeyText)->second.Height};
		GeneralBlt(m_StringTexture.find(KeyText)->second.Texture, x, y, Color, &SrcRect, BlendOp, SrcBlend, DestBlend, 1.0, 1.0, Degree);

		//eNX`̍ŌɎQƂꂽԂXV
		m_StringTexture.find(KeyText)->second.LastRefTime = timeGetTime();

	}

}
//ėp]
void DX9AGraphic::GeneralBlt(LPDIRECT3DTEXTURE9 Texture, int x, int y, D3DCOLOR Color, const RECT* SrcRect, D3DBLENDOP BlendOp, D3DBLEND SrcBlend, D3DBLEND DestBlend, float ScalingX, float ScalingY, float Degree){
	if(Texture){
		BeginScene();
		BeginSprite();
		//}gbNXݒ
		//ϊs񏉊
		D3DXMATRIX Mat;
		D3DXMatrixIdentity(&Mat);
		//g又
		D3DXMATRIX Scaling;
		D3DXMatrixScaling(&Scaling, ScalingX, ScalingY, 1.0f);
		//]iS_FXvCg̒SWj
		D3DXMATRIX Rotation, t1, t2;
		float ox = SrcRect ? static_cast<float>(SrcRect->right - SrcRect->left) * ScalingX / 2.0f : 0.0f;
		float oy = SrcRect ? static_cast<float>(SrcRect->bottom - SrcRect->top) * ScalingY / 2.0f : 0.0f;
		D3DXMatrixTranslation(&t1, -ox, -oy, 0.0f);
		D3DXMatrixRotationZ(&Rotation, D3DXToRadian(Degree));
		D3DXMatrixTranslation(&t2, ox, oy, 0.0f);
		Rotation = t1 * Rotation * t2;
		//ړ
		D3DXMATRIX Translation;
		D3DXMatrixTranslation(&Translation, static_cast<float>(x), static_cast<float>(y), 0.0f);
		//s
		Mat = Scaling * Rotation * Translation;
		//gXtH[Xe[gݒ
		m_pD3DXSprite->SetTransform(&Mat);
		//_OXe[gݒ
		m_pD3DDevice->SetRenderState(D3DRS_BLENDOP, BlendOp);
		m_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, SrcBlend);
		m_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, DestBlend);
		//]
		m_pD3DXSprite->Draw(Texture, SrcRect, NULL, NULL, Color);
		m_pD3DXSprite->Flush();
	}
}

//`Jn
void DX9AGraphic::BeginScene(){
	if(!m_IsBeginScene){
		m_pD3DDevice->BeginScene();
		m_IsBeginScene = true;
	}
}
//`I
void DX9AGraphic::EndScene(){
	if(m_IsBeginScene){
		m_pD3DDevice->EndScene();
		m_IsBeginScene = false;
	}
}

//XvCg̕`Jn
void DX9AGraphic::BeginSprite(){
	if(!m_IsBeginSprite){
		m_pD3DXSprite->Begin(D3DXSPRITE_ALPHABLEND);
		m_IsBeginSprite = true;
	}
}
//XvCg̕`I
void DX9AGraphic::EndSprite(){
	if(m_IsBeginSprite){
		m_pD3DXSprite->End();
		m_IsBeginSprite = false;
	}
}

//AvP[V
bool DX9AGraphic::InitApp(LPCTSTR WindowName, WNDPROC WndProc, HICON hIcon, HCURSOR hCursor, HICON hIconSm){

	//EChENXݒ
	WNDCLASSEX wc = { sizeof(wc), CS_CLASSDC, WndProc, 0, 0, m_hInst,
					  hIcon, hCursor, NULL, NULL, WindowName, hIconSm};
	if(!RegisterClassEx(&wc)){
		DX9AErrOut("Failed : DX9AGraphic::InitApp() RegisterClassEx\n");
		return(false);
	}

	//EChE𐶐
	RECT WindowRect = {0};
	RECT DesktopRect = {0};
	GetWindowRect(GetDesktopWindow(), &DesktopRect);
	AdjustWindowRect(&m_WindowLastPos, WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU, FALSE);
	m_WindowLastPos.bottom -= m_WindowLastPos.top;
	m_WindowLastPos.right -= m_WindowLastPos.left;
	m_WindowLastPos.left = (DesktopRect.right - m_WindowLastPos.right) / 2;
	m_WindowLastPos.top = (DesktopRect.bottom - m_WindowLastPos.bottom) / 2;
	m_WindowLastPos.bottom += m_WindowLastPos.top;
	m_WindowLastPos.right += m_WindowLastPos.left;
	if(m_IsFullScreen){
		//tXN[[h
		WindowRect.top = 0;
		WindowRect.left = 0;
		WindowRect.right = m_ScreenWidth;
		WindowRect.bottom = m_ScreenHeight;
	}
	else{
		//EChE[h
		WindowRect.top = m_WindowLastPos.top;
		WindowRect.left = m_WindowLastPos.left;
		WindowRect.right = m_WindowLastPos.right - m_WindowLastPos.left;
		WindowRect.bottom = m_WindowLastPos.bottom - m_WindowLastPos.top;
	}
	m_hWnd = CreateWindow(WindowName, WindowName, m_IsFullScreen ? WS_POPUP : WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU,
						  WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom, NULL, NULL, m_hInst, NULL);
	if(!m_hWnd){
		DX9AErrOut("Failed : DX9AGraphic::InitApp() CreateWindow\n");
		return(false);
	}

	ShowWindow(m_hWnd, SW_SHOW);
	UpdateWindow(m_hWnd);
	return(true);
}
//Direct3DɊǗĂIuWFNg
bool DX9AGraphic::InitD3D(){

	//Direct3D9IuWFNg
	m_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if(!m_pD3D){
		DX9AErrOut("Failed : DX9AGraphic::InitD3D() Direct3DCreate9\n");
		return(false);
	}

	//foCX̐ݒI
	UINT Adapter;
	D3DDEVTYPE Device;
	if(!SelectD3DDevice(Adapter, Device)){
		DX9AErrOut("Failed : DX9AGraphic::InitD3D() SelectD3DDevice\n");
		return(false);
	}

	//Direct3DDevice9IuWFNg
	if(m_IsFullScreen){
		m_D3DParamNow = m_D3DParamFull;
	}
	else{
		m_D3DParamNow = m_D3DParamWin;
	}

	if(FAILED(m_pD3D->CreateDevice(Adapter, Device, m_hWnd, D3DCREATE_MIXED_VERTEXPROCESSING, &m_D3DParamNow, &m_pD3DDevice))){
		if(FAILED(m_pD3D->CreateDevice(Adapter, Device, m_hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &m_D3DParamNow, &m_pD3DDevice))){
			if(FAILED(m_pD3D->CreateDevice(Adapter, Device, m_hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &m_D3DParamNow, &m_pD3DDevice))){
				DX9AErrOut("Failed : DX9AGraphic::InitD3D() CreateDevice\n");
				return(false);
			}
		}
	}

	//r[|[gݒ
	D3DVIEWPORT9 vp;
	vp.X = 0;
	vp.Y = 0;
	vp.Width = m_D3DParamNow.BackBufferWidth;
	vp.Height = m_D3DParamNow.BackBufferHeight;
	vp.MinZ = 0.0f;
	vp.MaxZ = 1.0f;
	if(FAILED(m_pD3DDevice->SetViewport(&vp))){
		DX9AErrOut("Failed : DX9AGraphic::InitD3D() SetViewport\n");
		return(false);
	}

	//eNX`
	if(FAILED(D3DXCreateTexture(m_pD3DDevice, 2, 2, D3DX_DEFAULT, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &m_pDrawRect))){
		DX9AErrOut("Failed : DX9AGraphic::InitD3D() D3DXCreateTexture\n");
		return(false);
	}
	else{
		D3DLOCKED_RECT LockedRect;
		if(FAILED(m_pDrawRect->LockRect(0, &LockedRect, NULL, D3DLOCK_DISCARD))){
			if(FAILED(m_pDrawRect->LockRect(0, &LockedRect, NULL, 0))){
				DX9AErrOut("Failed : DX9AGraphic::InitD3D() LockRect\n");
				return(false);
			}
		}
		D3DCOLOR RectColor = D3DCOLOR_ARGB(255, 255, 255, 255);
		for(int y=0;y<2;y++){
			for(int x=0;x<2;x++){
				memcpy(reinterpret_cast<BYTE*>(LockedRect.pBits)+LockedRect.Pitch*y+4*x, &RectColor, sizeof(RectColor));
			}
		}
		m_pDrawRect->UnlockRect(0);
	}

	//XvCg
	if(FAILED(D3DXCreateSprite(m_pD3DDevice, &m_pD3DXSprite))){
		DX9AErrOut("Failed : DX9AGraphic::InitD3D() D3DXCreateSprite\n");
		return(false);
	}

	//bZ[W{bNX\\ȃ[hɐݒ
	m_pD3DDevice->SetDialogBoxMode(true);

	return(true);
}
//foCX̐ݒI
bool DX9AGraphic::SelectD3DDevice(UINT& Adapter, D3DDEVTYPE& Device){

	HRESULT hr;

	//A_v^I
	Adapter = D3DADAPTER_DEFAULT;

	//foCX̔\͂擾
	D3DCAPS9 Caps;
	//HALfoCX`FbN
	Device = D3DDEVTYPE_HAL;
	hr = m_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
	if(FAILED(hr) || !CheckDeviceCaps(&Caps)){
		DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() GetDeviceCaps HAL\n");

		//REFfoCX`FbN
		Device = D3DDEVTYPE_REF;
		hr = m_pD3D->GetDeviceCaps(Adapter, Device, &Caps);
		if(FAILED(hr) || !CheckDeviceCaps(&Caps)){
			DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() GetDeviceCaps REF\n");
			return(false);
		}

	}

	//݂̃fBXvC̃tH[}bgȂǂ擾
	D3DDISPLAYMODE DMode;
	if(FAILED(m_pD3D->GetAdapterDisplayMode(Adapter, &DMode))){
		DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() GetAdapterDisplayMode\n");
		return(false);
	}

	//fBXvCƃobNobt@̃tH[}bg𒲍
	if(!SelectAdapterFormat(Adapter, Device, DMode)){
		DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() SelectAdapterFormat\n");
		return(false);
	}

	//[x^XeVobt@̃tH[}bg𒲍
	if(m_IsUseDepthStencil){
		if(!SelectDepthStencilFormat(Adapter, Device, DMode)){
			DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() SelectDepthStencilFormat\n");
			return(false);
		}
	}

	//_OeNX`̃tH[}bg𒲍
	if(!SelectRenderTextureFormat(Adapter, Device, DMode)){
		DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() SelectRenderTextureFormat\n");
		return(false);
	}

	//tV[A`GCAVO𒲍
	if(m_IsUseMultiSample){
		if(!SelectMultiSampleType(Adapter, Device)){
			DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() SelectMultiSampleType\n");
			return(false);
		}
	}

	//fBXvC[h𒲍
	if(!SelectDisplayMode(Adapter)){
		DX9AErrOut("Failed : DX9AGraphic::SelectD3DDevice() SelectDisplayMode\n");
		return(false);
	}

	return(true);
}
//foCX̔\͂`FbN
bool DX9AGraphic::CheckDeviceCaps(D3DCAPS9* Caps){
	//v~eBu
	if(REFCOND_MAXPRIMITIVECOUNT){
		DX9AErrOut("Failed : DX9AGraphic::CheckDeviceCaps() MaxPrimitiveCount(0x%X)\n", Caps->MaxPrimitiveCount);
		return(false);
	}
	//CfbNX
	if(REFCOND_MAXVERTEXINDEX){
		DX9AErrOut("Failed : DX9AGraphic::CheckDeviceCaps() MaxVertexIndex(0x%X)\n", Caps->MaxVertexIndex);
		return(false);
	}
	//_VF[_o[W
	if(REFCOND_VERTEXSHADERVERSION){
		DX9AErrOut("Failed : DX9AGraphic::CheckDeviceCaps() VertexShaderVersion(%d.%d)\n", D3DSHADER_VERSION_MAJOR(Caps->VertexShaderVersion), D3DSHADER_VERSION_MINOR(Caps->VertexShaderVersion));
		return(false);
	}
	//sNZVF[_o[W
	if(REFCOND_PIXELSHADERVERSION){
		DX9AErrOut("Failed : DX9AGraphic::CheckDeviceCaps() PixelShaderVersion(%d.%d)\n", D3DSHADER_VERSION_MAJOR(Caps->PixelShaderVersion), D3DSHADER_VERSION_MINOR(Caps->PixelShaderVersion));
		return(false);
	}
	UNREFERENCED_PARAMETER(Caps);
	return(true);
}
//fBXvCƃobNobt@̃tH[}bg𒲍
bool DX9AGraphic::SelectAdapterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode){

	HRESULT hr = S_OK;

	//]tH[}bg
	D3DFORMAT FmtDisplay[] = FMT_DISPLAY;

	//EChE[h
	m_D3DParamWin.BackBufferCount = 1;
	m_D3DParamWin.SwapEffect = D3DSWAPEFFECT_DISCARD;
	m_D3DParamWin.hDeviceWindow = m_hWnd;
	m_D3DParamWin.Windowed = TRUE;
	m_D3DParamWin.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
	m_D3DParamWin.PresentationInterval = D3DPRESENT_INTERVAL_DEFAULT;

	for(int i=0;i<sizeof(FmtDisplay)/sizeof(FmtDisplay[0]);i++){
		hr = m_pD3D->CheckDeviceType(Adapter, Device, DMode.Format, FmtDisplay[i], TRUE);
		if(SUCCEEDED(hr)){
			m_D3DParamWin.BackBufferFormat = FmtDisplay[i];
			break;
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectAdapterFormat() CheckDeviceType Window\n");
		return(false);
	}

	//tXN[[h
	m_D3DParamFull.BackBufferCount = 1;
	m_D3DParamFull.SwapEffect = D3DSWAPEFFECT_DISCARD;
	m_D3DParamFull.hDeviceWindow = m_hWnd;
	m_D3DParamFull.Windowed = FALSE;
	m_D3DParamFull.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
	m_D3DParamFull.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;

	for(int i=0;i<sizeof(FmtDisplay)/sizeof(FmtDisplay[0]);i++){
		hr = m_pD3D->CheckDeviceType(Adapter, Device, FmtDisplay[i], FmtDisplay[i], FALSE);
		if(SUCCEEDED(hr)){
			m_D3DParamFull.BackBufferFormat = FmtDisplay[i];
			break;
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectAdapterFormat() CheckDeviceType FullScreen\n");
		return(false);
	}

	return(true);
}
//[x^XeVobt@̃tH[}bg𒲍
bool DX9AGraphic::SelectDepthStencilFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode){

	HRESULT hr = S_OK;

	//]tH[}bg
	D3DFORMAT FmtDepthStencil[] = FMT_DEPTHSTENCIL;

	//EChE[h
	for(int i=0;i<sizeof(FmtDepthStencil)/sizeof(FmtDepthStencil[0]);i++){
		hr = m_pD3D->CheckDeviceFormat(Adapter, Device, DMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, FmtDepthStencil[i]);
		if(SUCCEEDED(hr)){
			hr = m_pD3D->CheckDepthStencilMatch(Adapter, Device, DMode.Format, m_D3DParamWin.BackBufferFormat, FmtDepthStencil[i]);
			if(SUCCEEDED(hr)){
				m_D3DParamWin.EnableAutoDepthStencil = TRUE;
				m_D3DParamWin.AutoDepthStencilFormat = FmtDepthStencil[i];
				break;
			}
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectDepthStencilFormat() Window\n");
		return(false);
	}

	//tXN[[h
	for(int i=0;i<sizeof(FmtDepthStencil)/sizeof(FmtDepthStencil[0]);i++){
		hr = m_pD3D->CheckDeviceFormat(Adapter, Device, m_D3DParamFull.BackBufferFormat, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, FmtDepthStencil[i]);
		if(SUCCEEDED(hr)){
			hr = m_pD3D->CheckDepthStencilMatch(Adapter, Device, m_D3DParamFull.BackBufferFormat, m_D3DParamFull.BackBufferFormat, FmtDepthStencil[i]);
			if(SUCCEEDED(hr)){
				m_D3DParamFull.EnableAutoDepthStencil = TRUE;
				m_D3DParamFull.AutoDepthStencilFormat = FmtDepthStencil[i];
				break;
			}
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectDepthStencilFormat() FullScreen\n");
		return(false);
	}

	return(true);
}
//_OeNX`̃tH[}bg𒲍
bool DX9AGraphic::SelectRenderTextureFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode){

	HRESULT hr = S_OK;

	//]tH[}bg
	D3DFORMAT FmtRenderTexture[] = FMT_RENDERTEXTURE;

	//EChE[h
	m_FmtRenderTextureWin = D3DFMT_UNKNOWN;
	for(int i=0;i<sizeof(FmtRenderTexture)/sizeof(FmtRenderTexture[0]);i++){
		hr = m_pD3D->CheckDeviceFormat(Adapter, Device, DMode.Format, D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, FmtRenderTexture[i]);
		if(SUCCEEDED(hr)){
			if(m_D3DParamWin.EnableAutoDepthStencil==TRUE){
				hr = m_pD3D->CheckDepthStencilMatch(Adapter, Device, DMode.Format, FmtRenderTexture[i],	m_D3DParamWin.AutoDepthStencilFormat);
				if(SUCCEEDED(hr)){
					m_FmtRenderTextureWin = FmtRenderTexture[i];
					break;
				}
			}
			else{
				m_FmtRenderTextureWin = FmtRenderTexture[i];
				break;
			}
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectRenderTextureFormat() Window\n");
		return(false);
	}

	//tXN[[h
	m_FmtRenderTextureFull = D3DFMT_UNKNOWN;
	for(int i=0;i<sizeof(FmtRenderTexture)/sizeof(FmtRenderTexture[0]);i++){
		hr = m_pD3D->CheckDeviceFormat(Adapter, Device, m_D3DParamFull.BackBufferFormat, D3DUSAGE_RENDERTARGET, D3DRTYPE_TEXTURE, FmtRenderTexture[i]);
		if(SUCCEEDED(hr)){
			if(m_D3DParamFull.EnableAutoDepthStencil==TRUE){
				hr = m_pD3D->CheckDepthStencilMatch(Adapter, Device, m_D3DParamFull.BackBufferFormat, FmtRenderTexture[i],	m_D3DParamFull.AutoDepthStencilFormat);
				if(SUCCEEDED(hr)){
					m_FmtRenderTextureFull = FmtRenderTexture[i];
					break;
				}
			}
			else{
				m_FmtRenderTextureFull = FmtRenderTexture[i];
				break;
			}
		}
	}
	if(FAILED(hr)){
		DX9AErrOut("Failed : DX9AGraphic::SelectRenderTextureFormat() FullScreen\n");
		return(false);
	}

	return(true);
}
//tV[A`GCAVO𒲍
bool DX9AGraphic::SelectMultiSampleType(UINT Adapter, D3DDEVTYPE Device){

	//]tH[}bg
	D3DMULTISAMPLE_TYPE MST[] = TYPE_MULTISAMPLE;

	//EChE[h
	for(int i=0;i<sizeof(MST)/sizeof(MST[0]);i++){
		if(FAILED(m_pD3D->CheckDeviceMultiSampleType(Adapter, Device, m_D3DParamWin.BackBufferFormat, TRUE, MST[i], NULL))){
			continue;
		}
		if(m_D3DParamWin.EnableAutoDepthStencil==TRUE){
			if(FAILED(m_pD3D->CheckDeviceMultiSampleType(Adapter, Device, m_D3DParamWin.AutoDepthStencilFormat, TRUE, MST[i], NULL))){
				continue;
			}
		}
		m_D3DParamWin.MultiSampleType = MST[i];
		m_D3DParamWin.MultiSampleQuality = 0;
		break;
	}

	//tXN[[h
	for(int i=0;i<sizeof(MST)/sizeof(MST[0]);i++){
		if(FAILED(m_pD3D->CheckDeviceMultiSampleType(Adapter, Device, m_D3DParamFull.BackBufferFormat, FALSE, MST[i], NULL))){
			continue;
		}
		if(m_D3DParamFull.EnableAutoDepthStencil==TRUE){
			if(FAILED(m_pD3D->CheckDeviceMultiSampleType(Adapter, Device, m_D3DParamFull.AutoDepthStencilFormat, FALSE, MST[i], NULL))){
				continue;
			}
		}
		m_D3DParamFull.MultiSampleType = MST[i];
		m_D3DParamFull.MultiSampleQuality = 0;
		break;
	}

	return(true);
}
//fBXvC[h𒲍
bool DX9AGraphic::SelectDisplayMode(UINT Adapter){

	//EChE[hisvj

	//tXN[[h
	int level = INT_MAX;
	D3DDISPLAYMODE DMode = {0, 0, 0, D3DFMT_UNKNOWN};
	int Num = m_pD3D->GetAdapterModeCount(Adapter, m_D3DParamFull.BackBufferFormat);

	for(int i=0;i<Num;i++){
		//fBXvC[h̗
		D3DDISPLAYMODE DM;
		m_pD3D->EnumAdapterModes(Adapter, m_D3DParamFull.BackBufferFormat, i, &DM);
		int l = abs(m_ScreenWidth - static_cast<int>(DM.Width)) + abs(m_ScreenHeight - static_cast<int>(DM.Height));
		if(l<level){
			//K؂ȃ[hI
			DMode = DM;
			level = l;
		}
	}
	if(DMode.Format==D3DFMT_UNKNOWN){
		DX9AErrOut("Failed : DX9AGraphic::SelectDisplayMode()\n");
		return(false);
	}

	m_D3DParamFull.BackBufferWidth = DMode.Width;
	m_D3DParamFull.BackBufferHeight = DMode.Height;

	return(true);
}
//Direct3DɊǗĂȂIuWFNg
bool DX9AGraphic::InitD3DObject(){
	//XvCg̊Ǘ
	if(m_pD3DXSprite){
		m_pD3DXSprite->OnResetDevice();
	}
	//_OXe[gݒ
	//Zobt@
	m_pD3DDevice->SetRenderState(D3DRS_ZENABLE, m_D3DParamNow.EnableAutoDepthStencil ? D3DZB_TRUE : D3DZB_FALSE);
	//}`TvO
	m_pD3DDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, m_D3DParamNow.MultiSampleType!=D3DMULTISAMPLE_NONE ? TRUE : FALSE);

	return(true);
}

//Direct3DɊǗĂȂIuWFNg̏I
bool DX9AGraphic::CleanupD3DObject(){
	if(m_pD3DXSprite){
		m_pD3DXSprite->OnLostDevice();
	}

	return(true);
}
//Direct3DɊǗĂIuWFNg̏I
bool DX9AGraphic::CleanupD3D(){
	for(map<string, StringTexture>::iterator it=m_StringTexture.begin();it!=m_StringTexture.end();it++){
		SAFE_RELEASE(it->second.Texture);
	}
	SAFE_RELEASE(m_pDrawRect);
	SAFE_RELEASE(m_pD3DXSprite);
	SAFE_RELEASE(m_pD3DDevice);
	SAFE_RELEASE(m_pD3D);

	return(true);
}
//AvP[V̏I
bool DX9AGraphic::CleanupApp(){
	UnregisterClass(m_ClassName.c_str(), m_hInst);

	return(true);
}



//ftHgRXgN^
DX9AGraphicAccessor::DX9AGraphicAccessor(){
	Outer = NULL;
}

//eGWݒ
void DX9AGraphicAccessor::SetParent(DX9AGraphic* Parent){
	Outer = Parent;
}

//Direct3D9IuWFNg擾
LPDIRECT3D9 DX9AGraphicAccessor::GetD3D9(){
	return(Outer->m_pD3D);
}
//XvCgIuWFNg擾
LPD3DXSPRITE DX9AGraphicAccessor::GetD3DXSprite(){
	return(Outer->m_pD3DXSprite);
}
//Direct3DDevice9IuWFNg擾
LPDIRECT3DDEVICE9 DX9AGraphicAccessor::GetD3D9Device(){
	return(Outer->m_pD3DDevice);
}



//ANZbT
static DX9AGraphicAccessor DX9ASingletonDX9AGraphicAccessor;
//ANZbT擾
DX9AGraphicAccessor* GetDX9AGraphicAccessor(DX9AGraphic* Parent){
	DX9ASingletonDX9AGraphicAccessor.SetParent(Parent);
	return(&DX9ASingletonDX9AGraphicAccessor);
}

}
}
}