#include "stdafx.h"
#include "../index.h"
#include "IDraw2DReader.h"

namespace nsDX9A{
namespace nsGraphics{
namespace nsIDraw2DReader{

//RXgN^iDirectX Graphicsbp[At@C̓NXAt@CAFwj
CDraw2DReader::CDraw2DReader(DX9AGraphic* Outer, IFileReader* FileReader, const string& FileName, D3DCOLOR ColorKey){
	m_FileReader = FileReader;
	m_TextureData = NULL;
	m_Texture = NULL;
	m_Outer = Outer;
	if(FileName!=""){
		Read(FileName, ColorKey);
	}
}
//fXgN^iÓIȊ蓖Ă֎~j
CDraw2DReader::~CDraw2DReader(){
	SAFE_RELEASE(m_Texture);
	SAFE_DELETE_ARRAY(m_TextureData);
	SAFE_DELETE(m_FileReader);
}

//
void CDraw2DReader::Release(){
	delete(this);
}

//ǂݍ
bool CDraw2DReader::Read(const string& FileName, D3DCOLOR ColorKey){
	if(!m_FileReader){
		DX9AErrOut("Failed : CDraw2DReader::Read FileReader Not Exists\n");
		return(false);
	}
	if(!m_FileReader->fopen(FileName.c_str(), "rb")){
		DX9AErrOut("Failed : CDraw2DReader::Read File Not Found(%s)\n", FileName.c_str());
		return(false);
	}
	SAFE_RELEASE(m_Texture);
	SAFE_DELETE_ARRAY(m_TextureData);
	long FileSize = m_FileReader->fsize();
	m_TextureData = new BYTE[FileSize];
	m_FileReader->fread(m_TextureData, FileSize, 1);
	m_FileReader->fclose();
	return(SUCCEEDED(D3DXCreateTextureFromFileInMemoryEx(GetDX9AGraphicAccessor(m_Outer)->GetD3D9Device(), 
														 m_TextureData, FileSize, D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, 
														 D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, D3DX_FILTER_NONE, D3DX_DEFAULT, ColorKey, NULL, NULL, &m_Texture)));
}
//ǂݍݍς݂H
bool CDraw2DReader::IsRead() const{
	return(m_Texture!=NULL);
}

//eNX`擾(1)
LPDIRECT3DTEXTURE9 CDraw2DReader::GetTexture(){
	return(m_Texture);
}
//eNX`擾(2)
LPDIRECT3DTEXTURE9 CDraw2DReader::GetTexture() const{
	return(m_Texture);
}

}
}
}