#include "stdafx.h"
#include "../index.h"
#include "IDraw2DText.h"

namespace nsDX9A{
namespace nsGraphics{
namespace nsIDraw2DText{

//RXgN^iDirectX Graphicsbp[wj
CDraw2DText::CDraw2DText(DX9AGraphic* Outer){
	m_StringTextureNowSize = 0;
	m_StringTextureMaxSize = 0;
	m_KeyTextHeight = 0;
	m_Size = 0;
	m_IsBold = false;
	m_IsItalic = false;
	m_Outer = Outer;
}
//fXgN^
CDraw2DText::~CDraw2DText(){
	for(map<string, ChTexture>::iterator it=m_ChTextures.begin();it!=m_ChTextures.end();it++){
		SAFE_RELEASE(it->second.Texture);
	}
}

//eNX`̍őTCYݒ
void CDraw2DText::SetStringTextureMaxSize(unsigned int StringTextureMaxSize){
	m_StringTextureMaxSize = StringTextureMaxSize;
}

//2DeLXgݒ
void CDraw2DText::SetText(const string& Text, const string& Font, unsigned int Size, bool IsBold, bool IsItalic){
	//֐pNX
	class InnerFunction{
	public:
		//𕶎Qɕ
		static void ResolveText(const string& Text, vector<string>& Chs){
			Chs.clear();
			for(unsigned int i=0;Text[i]!='\0';){
				unsigned int ChByte = ((Text[i]>=static_cast<char>(0x81) && Text[i]<=static_cast<char>(0x9F)) || 
									  (Text[i]>=static_cast<char>(0xE0) && Text[i]<=static_cast<char>(0xFF))) ? 2 : 1;
				Chs.push_back(string(Text.c_str()+i, ChByte));
				i += ChByte;
			}
		}
		//eLXgi`掞ɗpj𐶐
		static void CreateKeyText(const vector<string>& Chs, const string& Font, unsigned int Size, bool IsBold, bool IsItalic, vector<string>& KeyText){
			KeyText.clear();
			char Suffix[1024] = {0};
			sprintf(Suffix, "_%s_%d_%d", Font.c_str(), Size, (IsBold ? 1 : 0) + (IsItalic ? 2 : 0));
			for(vector<string>::const_iterator it=Chs.begin();it!=Chs.end();it++){
				if((*it)=="\n"){
					KeyText.push_back("\n");
				}
				else{
					KeyText.push_back((*it) + Suffix);
				}
			}
		}
		//GetGlyphOutlinepɃGR[h
		static void EncodeText(const string& Src, wstring& Dest){
			Dest.clear();
			for(unsigned int i=0;Src[i]!='\0';){
				unsigned int ChByte = ((Src[i]>=static_cast<char>(0x81) && Src[i]<=static_cast<char>(0x9F)) || 
									  (Src[i]>=static_cast<char>(0xE0) && Src[i]<=static_cast<char>(0xFF))) ? 2 : 1;
				Dest.push_back(ChByte==2 ? static_cast<BYTE>(Src[i]) * 256 + static_cast<BYTE>(Src[i+1]) : static_cast<BYTE>(Src[i]));
				i += ChByte;
			}
		}
	};

	unsigned int StringTextureNowSize = 0;
	m_Text = Text;
	m_KeyText.clear();
	m_KeyTextHeight = Size;
	m_Font = Font;
	m_Size = Size;
	m_IsBold = IsBold;
	m_IsItalic = IsItalic;
	//󕶎̏ꍇ
	if(Text==""){
		return;
	}
	//󕶎łȂꍇ
	else{
		vector<string> Chs;
		InnerFunction::ResolveText(Text, Chs);				//𕶎Qɕ
		InnerFunction::CreateKeyText(Chs, m_Font, m_Size, m_IsBold, m_IsItalic, m_KeyText);
															//eLXgi`掞ɗpj𐶐
		wstring UniChs;
		InnerFunction::EncodeText(Text, UniChs);			//GetGlyphOutlinepɃGR[h
		//tHg쐬
		LOGFONT LF = {Size, 0, 0, 0, (IsBold ? FW_BOLD : 0), (IsItalic ? TRUE : FALSE), 0, 0,
					  SHIFTJIS_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, ""};
		strcpy(LF.lfFaceName, Font.c_str());
		HFONT hFont;
		if((hFont = CreateFontIndirect(&LF))==0){
			DX9AErrOut("Failed : CDraw2DText::SetText() CreateFontIndirect\n");
			return;
		}
		//foCXReLXg擾
		HDC hDC = GetDC(NULL);
		HFONT OldFont = reinterpret_cast<HFONT>(SelectObject(hDC, hFont));
		//eNX`𐶐i݂Ȃꍇ̂݁j
		for(unsigned int i=0;i<m_KeyText.size();i++){
			UINT UniCh = UniChs[i];
			string KeyCh = m_KeyText.at(i);
			//sF
			if(KeyCh=="\n"){
				continue;
			}
			//eNX`쐬F쐬
			if(m_ChTextures.find(KeyCh)==m_ChTextures.end()){
				//eNX`̃TCY擾
				TEXTMETRIC TM;
				GLYPHMETRICS GM;
				UINT TexWidth = 0, TexHeight = 0;
				CONST MAT2 Mat = {{0, 1}, {0, 0}, {0, 0}, {0, 1}};
				GetTextMetrics(hDC, &TM);
				TexHeight = TM.tmHeight;
				GetGlyphOutline(hDC, UniCh, GGO_METRICS, &GM, 0, NULL, &Mat);
				TexWidth = GM.gmCellIncX;
				if(IsItalic){
					TexWidth += Size / 4;
				}
				unsigned int cnt;
				for(cnt=0;pow(2.0f, static_cast<float>(cnt))<TexWidth;cnt++);	TexWidth = static_cast<UINT>(pow(2.0f, static_cast<float>(cnt)));
				for(cnt=0;pow(2.0f, static_cast<float>(cnt))<TexHeight;cnt++);	TexHeight = static_cast<UINT>(pow(2.0f, static_cast<float>(cnt)));
				//eNX`̃p[^ݒ
				ChTexture stTemp;
				stTemp.Size = 4 * TexWidth * TexHeight;
				stTemp.Texture = NULL;
				stTemp.ChHeight = TM.tmHeight;
				stTemp.ChWidth = GM.gmCellIncX;
				stTemp.SrcRect.left = 0;
				stTemp.SrcRect.top = 0;
				stTemp.SrcRect.right = TexWidth;
				stTemp.SrcRect.bottom = TexHeight;
				m_StringTextureNowSize += stTemp.Size;
				if(UniCh==32/* pXy[X */ || UniCh==33088/* SpXy[X */){
					//pXy[XESpXy[X̏ꍇFeNX`mۂȂ
					stTemp.Size = 0;
				}
				else{
					//pXy[XESpXy[XȊȌꍇFeNX`mۂ
					//eNX`m
					if(FAILED(D3DXCreateTexture(GetDX9AGraphicAccessor(m_Outer)->GetD3D9Device(), TexWidth, TexHeight, 1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &(stTemp.Texture)))){
						DX9AErrOut("Failed : CDraw2DText::SetText() D3DXCreateTexture\n");
						SelectObject(hDC, OldFont);
						DeleteObject(hFont);
						ReleaseDC(NULL, hDC);
						return;
					}
					//tHgrbg}bv擾eNX`ɏ
					DWORD Alpha, Color;
					D3DLOCKED_RECT LockedRect;
					BYTE* p = new BYTE[stTemp.Size];
					int Bmp_W, Bmp_H, Ofs_X, Ofs_Y;
					if(FAILED(stTemp.Texture->LockRect(0, &LockedRect, NULL, D3DLOCK_DISCARD))){
						DX9AErrOut("Failed : CDraw2DText::SetText() LockRect\n");
						SelectObject(hDC, OldFont);
						DeleteObject(hFont);
						ReleaseDC(NULL, hDC);
						SAFE_DELETE_ARRAY(p);
						return;
					}
					FillMemory(LockedRect.pBits , LockedRect.Pitch * TexHeight, 0);
					GetGlyphOutline(hDC, UniCh, GGO_METRICS, &GM, 0, NULL, &Mat);
					GetGlyphOutline(hDC, UniCh, GGO_GRAY8_BITMAP, &GM, stTemp.Size, p, &Mat);
					Bmp_W = GM.gmBlackBoxX + (4 - (GM.gmBlackBoxX % 4)) % 4;
					Bmp_H = GM.gmBlackBoxY;
					Ofs_X = GM.gmptGlyphOrigin.x;
					Ofs_Y = TM.tmAscent - GM.gmptGlyphOrigin.y;
					for(int Y=0;Y<static_cast<int>(GM.gmBlackBoxY);Y++){
						for(int X=0;X<static_cast<int>(GM.gmBlackBoxX);X++){
							Alpha = (255 * p[Bmp_W * Y + X]) / 64;
							Color = 0x00ffffff | (Alpha << 24);
							memcpy((BYTE*)LockedRect.pBits+LockedRect.Pitch*(Ofs_Y+Y)+4*(Ofs_X+X), &Color, sizeof(Color)); 
						}
					}
					stTemp.Texture->UnlockRect(0);
					SAFE_DELETE_ARRAY(p);
				}
				m_ChTextures.insert(pair<string, ChTexture>(KeyCh, stTemp));
			}
			StringTextureNowSize += m_ChTextures.find(KeyCh)->second.Size;
			if(m_ChTextures.find(KeyCh)->second.ChHeight>m_KeyTextHeight){
				m_KeyTextHeight = m_ChTextures.find(KeyCh)->second.ChHeight;
			}
			m_ChTextures.find(KeyCh)->second.LastRefTime = timeGetTime();
		}
		//n
		SelectObject(hDC, OldFont);
		DeleteObject(hFont);
		ReleaseDC(NULL, hDC);
	}
	//eNX`̃TCYeNX`̍őTCY̏ꍇAeNX`̍őTCYIɊg
	if(StringTextureNowSize>m_StringTextureMaxSize){
		m_StringTextureMaxSize = StringTextureNowSize;
	}
	//eNX`̌݃TCYeNX`̍őTCY̏ꍇAeNX`̎ds
	if(m_StringTextureNowSize>m_StringTextureMaxSize){
		CutChTexture();
	}
}

//eLXg擾
const string& CDraw2DText::GetText() const{
	return(m_Text);
}
//tHg擾
const string& CDraw2DText::GetFont() const{
	return(m_Font);
}
//TCY擾
unsigned int CDraw2DText::GetSize() const{
	return(m_Size);
}
//擾
bool CDraw2DText::IsBold() const{
	return(m_IsBold);
}
//Α̂擾
bool CDraw2DText::IsItalic() const{
	return(m_IsItalic);
}

//2DeLXg`
void CDraw2DText::DrawText(int x, int y, D3DCOLOR Color, float Degree, D3DBLENDOP BlendOp, D3DBLEND SrcBlend, D3DBLEND DestBlend){
	//󕶎̏ꍇ
	if(m_KeyText.empty()){
		return;
	}
	//󕶎łȂꍇ
	else{
		int BaseX = x;
		int BaseY = y;
		for(vector<string>::iterator it=m_KeyText.begin();it!=m_KeyText.end();it++){
			if((*it)=="\n"){
				BaseX = x;
				BaseY += m_KeyTextHeight;
			}
			else{
				if(m_ChTextures.find(*it)->second.Texture){
					RECT SrcRect = {0, 0, m_ChTextures.find(*it)->second.ChWidth, m_ChTextures.find(*it)->second.ChHeight};
					m_Outer->GeneralBlt(m_ChTextures.find(*it)->second.Texture, BaseX, BaseY, Color, &SrcRect, BlendOp, SrcBlend, DestBlend, 1.0f, 1.0f, Degree);
				}
				m_ChTextures.find(*it)->second.LastRefTime = timeGetTime();
				BaseX += m_ChTextures.find(*it)->second.ChWidth;
			}
		}
	}
}

//eNX`팸
void CDraw2DText::CutChTexture(){
	DWORD Now = timeGetTime();
	map<string, ChTexture>::iterator it;
	while(m_StringTextureNowSize>m_StringTextureMaxSize){
		it = m_ChTextures.begin();
		for(map<string, ChTexture>::iterator it2=m_ChTextures.begin();it2!=m_ChTextures.end();it2++){
			if(Now-it2->second.LastRefTime>Now-it->second.LastRefTime){
				it = it2;
			}
			if(Now-it2->second.LastRefTime==Now-it->second.LastRefTime){
				if(it2->second.Size>it->second.Size){
					it = it2;
				}
			}
		}
		m_StringTextureNowSize -= it->second.Size;
		SAFE_RELEASE(it->second.Texture);
		m_ChTextures.erase(it);
	}
}

}
}
}
