#include "stdafx.h"
#include "../index.h"
#include "DX9ASound.h"

namespace nsDX9A{
namespace nsSound{
namespace nsDX9ASound{

//obt@쐬
static bool CreateVoidBuffer(LPDIRECTSOUND8 pDS8, LPDIRECTSOUNDBUFFER& pVoid){
	//Wavẽwb_
	WAVEFORMATEX WFEX;
	WFEX.wFormatTag			= WAVE_FORMAT_PCM;
	WFEX.nChannels			= 1;
	WFEX.wBitsPerSample		= 16;
	WFEX.nBlockAlign		= 2;
	WFEX.nSamplesPerSec		= 8000;
	WFEX.cbSize				= 0;
	WFEX.nAvgBytesPerSec	= 16000;
	//obt@쐬
	LPDIRECTSOUNDBUFFER pSecondaryBuffer;
	DSBUFFERDESC DSBD;
	ZeroMemory(&DSBD, sizeof(DSBD));
	DSBD.dwSize = sizeof(DSBD);
	DSBD.dwFlags = DSBCAPS_GLOBALFOCUS;
	DSBD.dwBufferBytes = 64000;
	DSBD.lpwfxFormat = &WFEX;
	if(FAILED(pDS8->CreateSoundBuffer(&DSBD, &pSecondaryBuffer, NULL))){
		DX9AErrOut("Failed : CreateVoidBuffer CreateSoundBuffer\n");
		return(false);
	}
	//f[^Zbg
	DWORD Len;
	BYTE* pWrite;
	if(FAILED(pSecondaryBuffer->Lock(0, 64000, reinterpret_cast<LPVOID*>(&pWrite), &Len, NULL, NULL, 0))){
		SAFE_RELEASE(pSecondaryBuffer);
		DX9AErrOut("Failed : CreateVoidBuffer Lock\n");
		return(false);
	}
	ZeroMemory(pWrite, 64000);
	if(FAILED(pSecondaryBuffer->Unlock(pWrite, Len, NULL, NULL))){
		pSecondaryBuffer->Unlock(pWrite, Len, NULL, NULL);
		SAFE_RELEASE(pSecondaryBuffer);
		DX9AErrOut("Failed : CreateVoidBuffer Unlock\n");
		return(false);
	}
	pVoid = pSecondaryBuffer;
	return(true);
}



//ftHgRXgN^
DX9ASound::DX9ASound(){
	m_pDS = NULL;
	m_pVoid = NULL;
}

//fXgN^
DX9ASound::~DX9ASound(){
	if(m_pVoid){
		if(FAILED(m_pVoid->Stop())){
			DX9AErrOut("Failed : DX9ASound::~DX9ASound Stop\n");
			m_pVoid->Stop();
		}
	}
	SAFE_RELEASE(m_pVoid);
	SAFE_RELEASE(m_pDS);
}

//iKĂяoƁj
bool DX9ASound::Init(HWND hWnd){
	//ς݂łI
	if(m_pDS){
		DX9AErrOut("Failed : DX9ASound::Init Already Initialized\n");
		return(false);
	}
	//DirectSound8IuWFNg쐬
	if(FAILED(DirectSoundCreate8(NULL, &m_pDS, NULL))){
		DX9AErrOut("Failed : DX9ASound::Init DirectSoundCreate8\n");
		return(false);
	}
	//xݒ
	if(FAILED(m_pDS->SetCooperativeLevel(hWnd, DSSCL_PRIORITY))){
		DX9AErrOut("Failed : DX9ASound::Init SetCooperativeLevel\n");
		return(false);
	}
	//vC}obt@쐬
	LPDIRECTSOUNDBUFFER pPrimaryBuffer = NULL;
	DSBUFFERDESC DSBD;
	ZeroMemory(&DSBD, sizeof(DSBD));
	DSBD.dwSize = sizeof(DSBD);
	DSBD.dwFlags = DSBCAPS_PRIMARYBUFFER;
	DSBD.dwBufferBytes = 0;
	DSBD.lpwfxFormat = NULL;
	if(FAILED(m_pDS->CreateSoundBuffer(&DSBD, &pPrimaryBuffer, NULL))){
		DX9AErrOut("Failed : DX9ASound::Init CreateSoundBuffer\n");
		return(false);
	}
	//vC}obt@̃tH[}bgݒ
	WAVEFORMATEX WFEX;
	ZeroMemory(&WFEX, sizeof(WFEX));
	WFEX.wFormatTag = WAVE_FORMAT_PCM;
	WFEX.nChannels = 2;
	WFEX.nSamplesPerSec = 44100;
	WFEX.wBitsPerSample = 16;
	WFEX.nBlockAlign = WFEX.wBitsPerSample / 8 * WFEX.nChannels;
	WFEX.nAvgBytesPerSec = WFEX.nSamplesPerSec * WFEX.nBlockAlign;
	if(FAILED(pPrimaryBuffer->SetFormat(&WFEX))){
		SAFE_RELEASE(pPrimaryBuffer);
		DX9AErrOut("Failed : DX9ASound::Init SetFormat\n");
		return(false);
	}
	//obt@쐬
	if(!CreateVoidBuffer(m_pDS, m_pVoid)){
		DX9AErrOut("Failed : DX9ASound::Init CreateVoidBuffer\n");
	}
	else{
		if(FAILED(m_pVoid->Play(0, 0, DSBPLAY_LOOPING))){
			DX9AErrOut("Failed : DX9ASound::Init Play\n");
		}
	}
	//n
	SAFE_RELEASE(pPrimaryBuffer);
	return(true);
}



//ftHgRXgN^
DX9ASoundAccessor::DX9ASoundAccessor(){
	Outer = NULL;
}

//eGWݒ
void DX9ASoundAccessor::SetParent(DX9ASound* Parent){
	Outer = Parent;
}

//DirectSound8IuWFNg擾
LPDIRECTSOUND8 DX9ASoundAccessor::GetDirectSound8(){
	return(Outer->m_pDS);
}



//ANZbT
static DX9ASoundAccessor DX9ASingletonDX9ASoundAccessor;
//ANZbT擾
DX9ASoundAccessor* GetDX9ASoundAccessor(DX9ASound* Parent){
	DX9ASingletonDX9ASoundAccessor.SetParent(Parent);
	return(&DX9ASingletonDX9ASoundAccessor);
}

}
}
}