#include "stdafx.h"
#include "../index.h"
#include "ISound.h"

namespace nsDX9A{
namespace nsSound{
namespace nsISound{

//RXgN^iDirectAudiobp[ATEhf[^ǂݍ݃NXwj
CSoundSE::CSoundSE(DX9ASound* Outer, ISoundReader* Reader){
	m_Reader = NULL;
	m_Outer = Outer;
	if(Reader){
		SetReader(Reader);
	}
}
//fXgN^
CSoundSE::~CSoundSE(){
	if(IsPlaying()){
		Stop();
	}
	for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		SAFE_RELEASE(*it);
	}
	SAFE_RELEASE(m_Reader);
}

//
void CSoundSE::Release(){
	delete(this);
}

//{[擾
long CSoundSE::GetVolume() const{
	if(m_Buffer.empty()){
		DX9AErrOut("Failed : CSoundSE::GetVolume Buffer Not Found\n");
		WARNING
	}
	LONG Volume;
	m_Buffer.front()->GetVolume(&Volume);
	return(Volume);
}
//{[ݒ
void CSoundSE::SetVolume(long Volume){
	if(m_Buffer.empty()){
		DX9AErrOut("Failed : CSoundSE::SetVolume Buffer Not Found\n");
		WARNING
	}
	if(Volume<-10000 || Volume>0){
		DX9AErrOut("Failed : CSoundSE::SetVolume Volume Out of Range(%d)\n", Volume);
		WARNING
	}
	for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		(*it)->SetVolume(Volume);
	}
}
//Đ
bool CSoundSE::Play(bool IsRepeat){
	if(m_Buffer.empty()){
		DX9AErrOut("Failed : CSoundSE::Play Buffer Not Found\n");
		return(false);
	}
	//Đł͂Ȃobt@F̃obt@ōĐ
	DWORD Status = 0;
	for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		if(SUCCEEDED((*it)->GetStatus(&Status)) && !(Status & DSBSTATUS_PLAYING)){
			(*it)->SetCurrentPosition(0);
			if(FAILED((*it)->Play(0, 0, IsRepeat ? DSBPLAY_LOOPING : 0))){
				DX9AErrOut("Failed : CSoundSE::Play\n");
				return(false);
			}
			else{
				return(true);
			}
		}
	}
	//Đł͂Ȃobt@ȂFVobt@쐬čĐ
	LPDIRECTSOUNDBUFFER pDSBD;
	GetDX9ASoundAccessor(m_Outer)->GetDirectSound8()->DuplicateSoundBuffer(m_Buffer.front(), &pDSBD);
	m_Buffer.push_back(pDSBD);
	pDSBD->SetCurrentPosition(0);
	m_Reader->SetLoopCount(IsRepeat ? -1 : 0);
	if(FAILED(pDSBD->Play(0, 0, IsRepeat ? DSBPLAY_LOOPING : 0))){
		DX9AErrOut("Failed : CSoundSE::Play\n");
		return(false);
	}
	else{
		return(true);
	}
}
//ĐH
bool CSoundSE::IsPlaying() const{
	if(m_Buffer.empty()){
		return(false);
	}
	DWORD Status = 0;
	for(list<LPDIRECTSOUNDBUFFER>::const_iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		if(SUCCEEDED((*it)->GetStatus(&Status)) && (Status & DSBSTATUS_PLAYING)){
			return(true);
		}
	}
	return(false);
}
//~
bool CSoundSE::Stop(){
	if(m_Buffer.empty()){
		DX9AErrOut("Failed : CSoundSE::Stop Buffer Not Found\n");
		return(false);
	}
	bool Result = true;
	for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		if(FAILED((*it)->Stop())){
			Result = false;
		}
	}
	if(!Result){
		DX9AErrOut("Failed : CSoundSE::Stop\n");
		return(false);
	}
	else{
		return(true);
	}
}

//TEhf[^ǂݍ݃NX擾(1)
ISoundReader* CSoundSE::GetReader(){
	return(m_Reader);
}
//TEhf[^ǂݍ݃NX擾(2)
ISoundReader* CSoundSE::GetReader() const{
	return(m_Reader);
}
//TEhf[^ǂݍ݃NXݒ
bool CSoundSE::SetReader(ISoundReader* Reader){
	//Ó`FbN
	if(Reader){
		if(!Reader->IsOpen()){
			DX9AErrOut("Failed : CSoundSE::SetReader() SoundReader Not IsOpen\n");
			return(false);
		}
	}
	else{
		if(IsPlaying()){
			Stop();
		}
		for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
			SAFE_RELEASE(*it);
		}
		m_Buffer.clear();
		SAFE_RELEASE(m_Reader);
		return(true);
	}
	//OTEhf[^
	if(IsPlaying()){
		Stop();
	}
	for(list<LPDIRECTSOUNDBUFFER>::iterator it=m_Buffer.begin();it!=m_Buffer.end();it++){
		SAFE_RELEASE(*it);
	}
	m_Buffer.clear();
	SAFE_RELEASE(m_Reader);
	//obt@쐬
	DWORD BufferSize;
	LPDIRECTSOUNDBUFFER pSecondaryBuffer;
	PCMWAVEFORMAT PCMWF = Reader->GetFormat();
	BufferSize = PCMWF.wf.nBlockAlign * Reader->GetTotal();
	DSBUFFERDESC DSBD;
	ZeroMemory(&DSBD, sizeof(DSBD));
	DSBD.dwSize = sizeof(DSBD);
	DSBD.dwFlags = DSBCAPS_CTRLVOLUME | DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCSOFTWARE;
	DSBD.dwBufferBytes = BufferSize;
	DSBD.lpwfxFormat = reinterpret_cast<LPWAVEFORMATEX>(&PCMWF);
	if(FAILED(GetDX9ASoundAccessor(m_Outer)->GetDirectSound8()->CreateSoundBuffer(&DSBD, &pSecondaryBuffer, NULL))){
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundSE::Load CreateSoundBuffer\n");
		return(false);
	}
	//f[^Zbg
	DWORD Len;
	BYTE* pWrite;
	if(FAILED(pSecondaryBuffer->Lock(0, BufferSize, reinterpret_cast<LPVOID*>(&pWrite), &Len, NULL, NULL, 0))){
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundSE::Load Lock\n");
		return(false);
	}
	if(!Reader->Read(pWrite, BufferSize, NULL)){
		pSecondaryBuffer->Unlock(pWrite, Len, NULL, NULL);
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundSE::Load Read\n");
		return(false);
	}
	if(FAILED(pSecondaryBuffer->Unlock(pWrite, Len, NULL, NULL))){
		pSecondaryBuffer->Unlock(pWrite, Len, NULL, NULL);
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundSE::Load Unlock\n");
		return(false);
	}
	//VTEhf[^ݒ
	m_Buffer.push_back(pSecondaryBuffer);
	m_Reader = Reader;
	return(true);
}



//RXgN^iDirectAudiobp[ATEhf[^ǂݍ݃NXwj
CSoundBGM::CSoundBGM(DX9ASound* Outer, ISoundReader* Reader){
	m_Buffer = NULL;
	m_Reader = NULL;
	m_Outer = Outer;

	m_BufferSize = 0;
	m_BufferNotifySize = 0;
	m_NotifyEvent[0] = NULL;
	m_NotifyEvent[1] = NULL;
	m_ThreadHandle = static_cast<DWORD>(-1);
	m_NextWrite = 0;
	m_NextRead = 0;
	m_LoopIn = 0;
	m_LoopOut = 0;
	m_Total = 0;
	m_Loop = 0;
	m_ValidBlocks = 0;
	if(Reader){
		SetReader(Reader);
	}
}
//fXgN^
CSoundBGM::~CSoundBGM(){
	{
		CCriticalSection CS;
		if(IsPlaying()){
			Stop();
		}
		SAFE_RELEASE(m_Buffer);
		if(m_NotifyEvent[1]){
			PulseEvent(m_NotifyEvent[1]);
			SAFE_CLOSEHANDLE(m_NotifyEvent[1]);
		}
		if(m_NotifyEvent[0]){
			SAFE_CLOSEHANDLE(m_NotifyEvent[0]);
		}
	}
	Sleep(1);
	SAFE_RELEASE(m_Reader);
}

//
void CSoundBGM::Release(){
	delete(this);
}

//{[擾
long CSoundBGM::GetVolume() const{
	if(!m_Buffer){
		DX9AErrOut("Failed : CSoundBGM::GetVolume Buffer Not Found\n");
		WARNING
	}
	CCriticalSection CS;
	LONG Volume;
	m_Buffer->GetVolume(&Volume);
	return(Volume);
}
//{[ݒ
void CSoundBGM::SetVolume(long Volume){
	if(!m_Buffer){
		DX9AErrOut("Failed : CSoundBGM::SetVolume Buffer Not Found\n");
		WARNING
	}
	if(Volume<-10000 || Volume>0){
		DX9AErrOut("Failed : CSoundBGM::SetVolume Volume Out of Range(%d)\n", Volume);
		WARNING
	}
	CCriticalSection CS;
	m_Buffer->SetVolume(Volume);
}
//Đ
bool CSoundBGM::Play(bool IsRepeat){
	if(!m_Buffer){
		DX9AErrOut("Failed : CSoundBGM::Play Buffer Not Found\n");
		return(false);
	}
	CCriticalSection CS;
	//~
	m_Buffer->Stop();
	//o
	m_Reader->Seek(0);
	m_Buffer->SetCurrentPosition(0);
	//ϐݒ
	m_NextWrite = 0;
	m_NextRead = 0;
	m_LoopIn = m_Reader->GetLoopIn() * m_PCMWF.wf.nBlockAlign;
	m_LoopOut = m_Reader->GetLoopOut() * m_PCMWF.wf.nBlockAlign;
	m_Total = m_Reader->GetTotal() * m_PCMWF.wf.nBlockAlign;
	m_Reader->SetLoopCount(IsRepeat ? -1 : 0);
	m_Loop = m_Reader->GetLoopCount();
	m_ValidBlocks = 0;
	//f[^Zbg
	for(int i=0;i<NUM_PLAY_NOTIFICATIONS-1;i++){
		FillBlock();
	}
	//Đ
	if(FAILED(m_Buffer->Play(0, 0, DSBPLAY_LOOPING))){
		DX9AErrOut("Failed : CSoundBGM::Play\n");
		return(false);
	}
	else{
		return(true);
	}
}
//ĐH
bool CSoundBGM::IsPlaying() const{
	if(!m_Buffer){
		return(false);
	}
	CCriticalSection CS;
	DWORD Status = 0;
	return(SUCCEEDED(m_Buffer->GetStatus(&Status)) && (Status & DSBSTATUS_PLAYING));
}
//~
bool CSoundBGM::Stop(){
	if(!m_Buffer){
		DX9AErrOut("Failed : CSoundBGM::Stop Buffer Not Found\n");
		return(false);
	}
	CCriticalSection CS;
	if(FAILED(m_Buffer->Stop())){
		DX9AErrOut("Failed : CSoundBGM::Stop\n");
		return(false);
	}
	else{
		return(true);
	}
}

//TEhf[^ǂݍ݃NX擾(1)
ISoundReader* CSoundBGM::GetReader(){
	return(m_Reader);
}
//TEhf[^ǂݍ݃NX擾(2)
ISoundReader* CSoundBGM::GetReader() const{
	return(m_Reader);
}
//TEhf[^ǂݍ݃NXݒ
bool CSoundBGM::SetReader(ISoundReader* Reader){
	//Ó`FbN
	if(Reader){
		if(!Reader->IsOpen()){
			DX9AErrOut("Failed : CSoundBGM::SetReader() SoundReader Not IsOpen\n");
			return(false);
		}
	}
	else{
		{
			CCriticalSection CS;
			if(IsPlaying()){
				Stop();
			}
			SAFE_RELEASE(m_Buffer);
			if(m_NotifyEvent[1]){
				PulseEvent(m_NotifyEvent[1]);
				SAFE_CLOSEHANDLE(m_NotifyEvent[1]);
			}
			if(m_NotifyEvent[0]){
				SAFE_CLOSEHANDLE(m_NotifyEvent[0]);
			}
		}
		Sleep(1);
		SAFE_RELEASE(m_Reader);
		return(true);
	}
	//OTEhf[^
	{
		CCriticalSection CS;
		if(IsPlaying()){
			Stop();
		}
		SAFE_RELEASE(m_Buffer);
		if(m_NotifyEvent[1]){
			PulseEvent(m_NotifyEvent[1]);
			SAFE_CLOSEHANDLE(m_NotifyEvent[1]);
		}
		if(m_NotifyEvent[0]){
			SAFE_CLOSEHANDLE(m_NotifyEvent[0]);
		}
	}
	Sleep(1);
	SAFE_RELEASE(m_Reader);
	//obt@̃TCYvZ
	DWORD BufferSize;
	DWORD BufferNotifySize;
	PCMWAVEFORMAT PCMWF = Reader->GetFormat();
	BufferNotifySize = (PCMWF.wf.nSamplesPerSec * BUFFER_TIME * PCMWF.wf.nBlockAlign) / NUM_PLAY_NOTIFICATIONS;
	int Rem = BufferNotifySize % static_cast<DWORD>(PCMWF.wf.nBlockAlign);
	if(Rem){
		BufferNotifySize += (PCMWF.wf.nBlockAlign - Rem);
	}
	BufferSize = BufferNotifySize * NUM_PLAY_NOTIFICATIONS;
	//obt@쐬
	LPDIRECTSOUNDBUFFER pSecondaryBuffer;
	DSBUFFERDESC DSBD;
	ZeroMemory(&DSBD, sizeof(DSBD));
	DSBD.dwSize = sizeof(DSBD);
	DSBD.dwFlags = DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_CTRLVOLUME | DSBCAPS_GLOBALFOCUS | DSBCAPS_LOCSOFTWARE;
	DSBD.dwBufferBytes = BufferSize;
	DSBD.lpwfxFormat = reinterpret_cast<LPWAVEFORMATEX>(&PCMWF);
	if(FAILED(GetDX9ASoundAccessor(m_Outer)->GetDirectSound8()->CreateSoundBuffer(&DSBD, &pSecondaryBuffer, NULL))){
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundBGM::Load CreateSoundBuffer\n");
		return(false);
	}
	//obt@ɒʒm|Cgݒ
	HANDLE NotifyEvent[2];
	LPDIRECTSOUNDNOTIFY Notify;
	if(FAILED(pSecondaryBuffer->QueryInterface(IID_IDirectSoundNotify, reinterpret_cast<LPVOID*>(&Notify)))){
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundBGM::Load QueryInterface\n");
		return(false);
	}
	//ʒmCxg쐬i0:Play, 1:Stopj
	NotifyEvent[0] = CreateEvent(NULL, FALSE, FALSE, NULL);
	NotifyEvent[1] = CreateEvent(NULL, FALSE, FALSE, NULL);
	//ĐCxgʒuZbg
	DSBPOSITIONNOTIFY NotifyPos[NUM_PLAY_NOTIFICATIONS];
	for(int i=0;i<NUM_PLAY_NOTIFICATIONS;i++){
		NotifyPos[i].dwOffset = BufferNotifySize * (i + 1);
		NotifyPos[i].hEventNotify = NotifyEvent[0];
	}
	NotifyPos[NUM_PLAY_NOTIFICATIONS-1].dwOffset -= 1;
	//obt@ɒʒmʒuݒ
	if(FAILED(Notify->SetNotificationPositions(NUM_PLAY_NOTIFICATIONS, NotifyPos))){
		SAFE_CLOSEHANDLE(NotifyEvent[0]);
		SAFE_CLOSEHANDLE(NotifyEvent[1]);
		SAFE_RELEASE(Notify);
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundBGM::Load SetNotificationPositions\n");
		return(false);
	}
	//VTEhf[^ݒ
	m_Buffer = pSecondaryBuffer;
	m_Reader = Reader;
	m_BufferSize = BufferSize;
	m_BufferNotifySize = BufferNotifySize;
	m_NotifyEvent[0] = NotifyEvent[0];
	m_NotifyEvent[1] = NotifyEvent[1];
	m_PCMWF = PCMWF;
	//ĐXbh쐬
	m_ThreadHandle = static_cast<DWORD>(_beginthread(HandleNotificationsStatic, 0, reinterpret_cast<void*>(this)));
	if(m_ThreadHandle==-1){
		SAFE_CLOSEHANDLE(NotifyEvent[0]);
		SAFE_CLOSEHANDLE(NotifyEvent[1]);
		SAFE_RELEASE(Notify);
		SAFE_RELEASE(pSecondaryBuffer);
		SAFE_RELEASE(Reader);
		DX9AErrOut("Failed : CSoundBGM::Load _beginthread\n");
		return(false);
	}
	SAFE_RELEASE(Notify);
	return(true);
}

//ĐpXbh
void CSoundBGM::HandleNotificationsStatic(void* pThis){
	(reinterpret_cast<CSoundBGM*>(pThis))->HandleNotifications();
}
//ĐpXbhiNXj
void CSoundBGM::HandleNotifications(){
	DWORD Event = 0;
	while((Event=WaitForMultipleObjects(2, m_NotifyEvent, FALSE, INFINITE))!=WAIT_FAILED){
		//Stop
		if(Event-WAIT_OBJECT_0==1){
			break;
		}
		//Play
		else if(Event-WAIT_OBJECT_0==0){
			CCriticalSection CS;
			//obt@݂Ȃ
			if(!m_Buffer){
				break;
			}
			//LȃubNЂƂ
			if(m_ValidBlocks>0){
				m_ValidBlocks -= 1;
			}
			//LȃubNȂAI[ɒBĂȂĐ~
			if(m_ValidBlocks==0 && m_Loop==0 && m_NextRead==m_Total){
				m_Buffer->Stop();
			}
			//܂ubN𖞂]nȂ疞
			if(m_ValidBlocks<NUM_PLAY_NOTIFICATIONS-1){
				FillBlock();
			}
		}
	}
}
//ubNɃf[^Zbg
bool CSoundBGM::FillBlock(){
	//bN
	DWORD Len;
	BYTE* pWrite;
	if(FAILED(m_Buffer->Lock(m_NextWrite, m_BufferNotifySize, reinterpret_cast<LPVOID*>(&pWrite), &Len, NULL, NULL, 0))){
		DX9AErrOut("Failed : CSoundBGM::FillBlock Lock\n");
		return(false);
	}
	//bNobt@͈̔͂Ƀf[^ǂݍ
	DWORD WriteSize = 0;
	while(WriteSize<m_BufferNotifySize){
		//ǂݍ݈ʒũ[v
		if(m_Loop!=0 && (m_NextRead==m_LoopOut || m_Reader->IsTerminated())){
			if(m_LoopIn>=m_LoopOut){
				if(m_Loop>0){
					m_Loop = 0;
				}
				//[vI
				else{
					break;
				}
			}
			//V[NłȂI
			if(!m_Reader->Seek(m_LoopIn/m_PCMWF.wf.nBlockAlign)){
				break;
			}
			m_NextRead = m_LoopIn;
			if(m_Loop>0){
				m_Loop -= 1;
			}
		}
		//xɓǂݍ߂邾ǂݍ
		const DWORD Limit = (m_Loop != 0) ? m_LoopOut : m_Total;
		const DWORD LimitSize = Limit - m_NextRead;
		const DWORD ReadSize = (LimitSize < (m_BufferNotifySize - WriteSize)) ? LimitSize : (m_BufferNotifySize - WriteSize);
		//I[ɒB
		if(ReadSize<=0){
			break;
		}
		//\I[ɒB
		if(m_Loop==0 && m_Reader->IsTerminated()){
			break;
		}
		DWORD ActualReadSize;
		//sH
		if(!m_Reader->Read(pWrite+WriteSize, ReadSize, &ActualReadSize)){
			break;
		}
		WriteSize += ActualReadSize;
		m_NextRead += ActualReadSize;
	}
	//LubNJEg𑝂₷
	if(WriteSize>0){
		m_ValidBlocks += 1;
	}
	//c0Ŗ߂
	if(WriteSize<m_BufferNotifySize){
		FillMemory(pWrite+WriteSize, m_BufferNotifySize-WriteSize, static_cast<BYTE>(m_PCMWF.wBitsPerSample==8 ? 128 : 0));
	}
	//݈ʒuړ
	m_NextWrite += m_BufferNotifySize;
	if(m_NextWrite>=m_BufferSize){
		m_NextWrite -= m_BufferSize;
	}
	//AbN
	if(FAILED(m_Buffer->Unlock(pWrite, Len, NULL, 0))){
		m_Buffer->Unlock(pWrite, Len, NULL, 0);
		DX9AErrOut("Failed : CSoundBGM::FillBlock Unlock\n");
		return(false);
	}

	return(true);
}

}
}
}